// Compiled by ClojureScript 1.7.48 {:target :nodejs}
goog.provide('gpio_socket.core');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('cljs.nodejs');
goog.require('clojure.walk');
goog.require('gpio_socket.gpio');
goog.require('gpio_socket.utils');
gpio_socket.core.ws = cljs.nodejs.require.call(null,"ws");
/**
 * Returns a transducer that filters changes to
 * only the given port.
 */
gpio_socket.core.filter_port = (function gpio_socket$core$filter_port(port){
return cljs.core.filter.call(null,(function (p1__9305_SHARP_){
return cljs.core._EQ_.call(null,cljs.core.first.call(null,p1__9305_SHARP_),port);
}));
});
/**
 * Returns a transducer that maps changes to
 * (notification) writes.
 */
gpio_socket.core.change__GT_write = (function gpio_socket$core$change__GT_write(){
return cljs.core.map.call(null,(function (p__9308){
var vec__9309 = p__9308;
var port = cljs.core.nth.call(null,vec__9309,(0),null);
var value = cljs.core.nth.call(null,vec__9309,(1),null);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"change","change",-1163046502),port,value], null);
}));
});
/**
 * Subscribe the given client to changes on the
 * specified port.
 */
gpio_socket.core.subscribe = (function gpio_socket$core$subscribe(p__9310,port){
var map__9313 = p__9310;
var map__9313__$1 = ((((!((map__9313 == null)))?((((map__9313.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9313.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9313):map__9313);
var client = map__9313__$1;
var out = cljs.core.get.call(null,map__9313__$1,new cljs.core.Keyword(null,"out","out",-910545517));
var subscriptions = cljs.core.get.call(null,map__9313__$1,new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776));
if(cljs.core.truth_(cljs.core.get.call(null,subscriptions,port))){
return client;
} else {
var subscription = cljs.core.async.chan.call(null);
cljs.core.async.pipe.call(null,cljs.core.async.pipe.call(null,cljs.core.async.pipe.call(null,cljs.core.async.tap.call(null,gpio_socket.gpio.changes_mult,subscription),cljs.core.async.chan.call(null,(1),gpio_socket.core.filter_port.call(null,port))),cljs.core.async.chan.call(null,(1),gpio_socket.core.change__GT_write.call(null))),out);

gpio_socket.gpio.watch.call(null,port);

return cljs.core.assoc_in.call(null,client,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776),port], null),subscription);
}
});
/**
 * Unsubscribe the given client to changes on the
 * specified port.
 */
gpio_socket.core.unsubscribe = (function gpio_socket$core$unsubscribe(p__9315,port){
var map__9318 = p__9315;
var map__9318__$1 = ((((!((map__9318 == null)))?((((map__9318.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9318.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9318):map__9318);
var client = map__9318__$1;
var subscriptions = cljs.core.get.call(null,map__9318__$1,new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776));
var temp__4423__auto__ = cljs.core.get.call(null,subscriptions,port);
if(cljs.core.truth_(temp__4423__auto__)){
var subscription = temp__4423__auto__;
cljs.core.async.untap.call(null,gpio_socket.gpio.changes_mult,subscription);

gpio_socket.gpio.unwatch.call(null,port);

return gpio_socket.utils.dissoc_in.call(null,client,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776),port], null));
} else {
return client;
}
});
gpio_socket.core.quit = (function gpio_socket$core$quit(p__9320){
var map__9327 = p__9320;
var map__9327__$1 = ((((!((map__9327 == null)))?((((map__9327.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9327.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9327):map__9327);
var client = map__9327__$1;
var in$ = cljs.core.get.call(null,map__9327__$1,new cljs.core.Keyword(null,"in","in",-1531184865));
var out = cljs.core.get.call(null,map__9327__$1,new cljs.core.Keyword(null,"out","out",-910545517));
var socket = cljs.core.get.call(null,map__9327__$1,new cljs.core.Keyword(null,"socket","socket",59137063));
var subscriptions = cljs.core.get.call(null,map__9327__$1,new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776));
var seq__9329_9333 = cljs.core.seq.call(null,cljs.core.keys.call(null,subscriptions));
var chunk__9330_9334 = null;
var count__9331_9335 = (0);
var i__9332_9336 = (0);
while(true){
if((i__9332_9336 < count__9331_9335)){
var port_9337 = cljs.core._nth.call(null,chunk__9330_9334,i__9332_9336);
gpio_socket.core.unsubscribe.call(null,client,port_9337);

var G__9338 = seq__9329_9333;
var G__9339 = chunk__9330_9334;
var G__9340 = count__9331_9335;
var G__9341 = (i__9332_9336 + (1));
seq__9329_9333 = G__9338;
chunk__9330_9334 = G__9339;
count__9331_9335 = G__9340;
i__9332_9336 = G__9341;
continue;
} else {
var temp__4425__auto___9342 = cljs.core.seq.call(null,seq__9329_9333);
if(temp__4425__auto___9342){
var seq__9329_9343__$1 = temp__4425__auto___9342;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__9329_9343__$1)){
var c__5332__auto___9344 = cljs.core.chunk_first.call(null,seq__9329_9343__$1);
var G__9345 = cljs.core.chunk_rest.call(null,seq__9329_9343__$1);
var G__9346 = c__5332__auto___9344;
var G__9347 = cljs.core.count.call(null,c__5332__auto___9344);
var G__9348 = (0);
seq__9329_9333 = G__9345;
chunk__9330_9334 = G__9346;
count__9331_9335 = G__9347;
i__9332_9336 = G__9348;
continue;
} else {
var port_9349 = cljs.core.first.call(null,seq__9329_9343__$1);
gpio_socket.core.unsubscribe.call(null,client,port_9349);

var G__9350 = cljs.core.next.call(null,seq__9329_9343__$1);
var G__9351 = null;
var G__9352 = (0);
var G__9353 = (0);
seq__9329_9333 = G__9350;
chunk__9330_9334 = G__9351;
count__9331_9335 = G__9352;
i__9332_9336 = G__9353;
continue;
}
} else {
}
}
break;
}

cljs.core.async.close_BANG_.call(null,in$);

cljs.core.async.close_BANG_.call(null,out);

socket.close();

return null;
});
gpio_socket.core.encode_message = (function gpio_socket$core$encode_message(data){
return JSON.stringify(cljs.core.clj__GT_js.call(null,data));
});
gpio_socket.core.parse_message = (function gpio_socket$core$parse_message(message){
return clojure.walk.keywordize_keys.call(null,JSON.parse(message));
});
if(typeof gpio_socket.core.handle_message !== 'undefined'){
} else {
gpio_socket.core.handle_message = (function (){var method_table__5442__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__5443__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__5444__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__5445__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__5446__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"gpio-socket.core","handle-message"),((function (method_table__5442__auto__,prefer_table__5443__auto__,method_cache__5444__auto__,cached_hierarchy__5445__auto__,hierarchy__5446__auto__){
return (function (client,message){
return cljs.core.keyword.call(null,cljs.core.first.call(null,message));
});})(method_table__5442__auto__,prefer_table__5443__auto__,method_cache__5444__auto__,cached_hierarchy__5445__auto__,hierarchy__5446__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__5446__auto__,method_table__5442__auto__,prefer_table__5443__auto__,method_cache__5444__auto__,cached_hierarchy__5445__auto__));
})();
}
cljs.core._add_method.call(null,gpio_socket.core.handle_message,new cljs.core.Keyword(null,"subscribe","subscribe",416253756),(function (client,p__9354){
var vec__9355 = p__9354;
var _ = cljs.core.nth.call(null,vec__9355,(0),null);
var port = cljs.core.nth.call(null,vec__9355,(1),null);
return gpio_socket.core.subscribe.call(null,client,port);
}));
cljs.core._add_method.call(null,gpio_socket.core.handle_message,new cljs.core.Keyword(null,"unsubscribe","unsubscribe",632650147),(function (client,p__9356){
var vec__9357 = p__9356;
var _ = cljs.core.nth.call(null,vec__9357,(0),null);
var port = cljs.core.nth.call(null,vec__9357,(1),null);
return gpio_socket.core.unsubscribe.call(null,client,port);
}));
cljs.core._add_method.call(null,gpio_socket.core.handle_message,new cljs.core.Keyword(null,"write","write",-1857649168),(function (client,p__9358){
var vec__9359 = p__9358;
var _ = cljs.core.nth.call(null,vec__9359,(0),null);
var port = cljs.core.nth.call(null,vec__9359,(1),null);
var value = cljs.core.nth.call(null,vec__9359,(2),null);
gpio_socket.gpio.write.call(null,port,value);

return client;
}));
cljs.core._add_method.call(null,gpio_socket.core.handle_message,new cljs.core.Keyword(null,"quit","quit",53285210),(function (client,p__9360){
var vec__9361 = p__9360;
var _ = cljs.core.nth.call(null,vec__9361,(0),null);
return gpio_socket.core.quit.call(null,client);
}));
cljs.core._add_method.call(null,gpio_socket.core.handle_message,new cljs.core.Keyword(null,"default","default",-1987822328),(function (p__9362,_){
var map__9363 = p__9362;
var map__9363__$1 = ((((!((map__9363 == null)))?((((map__9363.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9363.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9363):map__9363);
var client = map__9363__$1;
var out = cljs.core.get.call(null,map__9363__$1,new cljs.core.Keyword(null,"out","out",-910545517));
cljs.core.async.put_BANG_.call(null,out,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["error","invalid command"], null));

return client;
}));
gpio_socket.core.clients = cljs.core.atom.call(null,cljs.core.PersistentHashSet.EMPTY);
gpio_socket.core.create_client = (function gpio_socket$core$create_client(socket){
return new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"in","in",-1531184865),cljs.core.async.chan.call(null),new cljs.core.Keyword(null,"out","out",-910545517),cljs.core.async.chan.call(null),new cljs.core.Keyword(null,"socket","socket",59137063),socket,new cljs.core.Keyword(null,"subscriptions","subscriptions",1250949776),cljs.core.PersistentArrayMap.EMPTY], null);
});
gpio_socket.core.register_client = (function gpio_socket$core$register_client(socket){
var map__9434 = gpio_socket.core.create_client.call(null,socket);
var map__9434__$1 = ((((!((map__9434 == null)))?((((map__9434.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9434.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9434):map__9434);
var client = map__9434__$1;
var in$ = cljs.core.get.call(null,map__9434__$1,new cljs.core.Keyword(null,"in","in",-1531184865));
var out = cljs.core.get.call(null,map__9434__$1,new cljs.core.Keyword(null,"out","out",-910545517));
var c__6931__auto___9501 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out){
return (function (state_9451){
var state_val_9452 = (state_9451[(1)]);
if((state_val_9452 === (1))){
var inst_9436 = client;
var state_9451__$1 = (function (){var statearr_9453 = state_9451;
(statearr_9453[(7)] = inst_9436);

return statearr_9453;
})();
var statearr_9454_9502 = state_9451__$1;
(statearr_9454_9502[(2)] = null);

(statearr_9454_9502[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9452 === (2))){
var state_9451__$1 = state_9451;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9451__$1,(4),in$);
} else {
if((state_val_9452 === (3))){
var inst_9449 = (state_9451[(2)]);
var state_9451__$1 = state_9451;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9451__$1,inst_9449);
} else {
if((state_val_9452 === (4))){
var inst_9439 = (state_9451[(8)]);
var inst_9439__$1 = (state_9451[(2)]);
var state_9451__$1 = (function (){var statearr_9455 = state_9451;
(statearr_9455[(8)] = inst_9439__$1);

return statearr_9455;
})();
if(cljs.core.truth_(inst_9439__$1)){
var statearr_9456_9503 = state_9451__$1;
(statearr_9456_9503[(1)] = (5));

} else {
var statearr_9457_9504 = state_9451__$1;
(statearr_9457_9504[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9452 === (5))){
var inst_9436 = (state_9451[(7)]);
var inst_9439 = (state_9451[(8)]);
var inst_9441 = gpio_socket.core.handle_message.call(null,inst_9436,inst_9439);
var inst_9442 = (function (){var old_client = inst_9436;
var temp__4425__auto__ = inst_9439;
var message = inst_9439;
var new_client = inst_9441;
return ((function (old_client,temp__4425__auto__,message,new_client,inst_9436,inst_9439,inst_9441,state_val_9452,c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out){
return (function (p1__9365_SHARP_){
return gpio_socket.utils.conj_if.call(null,cljs.core.disj.call(null,p1__9365_SHARP_,old_client),new_client);
});
;})(old_client,temp__4425__auto__,message,new_client,inst_9436,inst_9439,inst_9441,state_val_9452,c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out))
})();
var inst_9443 = cljs.core.swap_BANG_.call(null,gpio_socket.core.clients,inst_9442);
var inst_9436__$1 = inst_9441;
var state_9451__$1 = (function (){var statearr_9458 = state_9451;
(statearr_9458[(7)] = inst_9436__$1);

(statearr_9458[(9)] = inst_9443);

return statearr_9458;
})();
var statearr_9459_9505 = state_9451__$1;
(statearr_9459_9505[(2)] = null);

(statearr_9459_9505[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9452 === (6))){
var state_9451__$1 = state_9451;
var statearr_9460_9506 = state_9451__$1;
(statearr_9460_9506[(2)] = null);

(statearr_9460_9506[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9452 === (7))){
var inst_9447 = (state_9451[(2)]);
var state_9451__$1 = state_9451;
var statearr_9461_9507 = state_9451__$1;
(statearr_9461_9507[(2)] = inst_9447);

(statearr_9461_9507[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out))
;
return ((function (switch__6866__auto__,c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out){
return (function() {
var gpio_socket$core$register_client_$_state_machine__6867__auto__ = null;
var gpio_socket$core$register_client_$_state_machine__6867__auto____0 = (function (){
var statearr_9465 = [null,null,null,null,null,null,null,null,null,null];
(statearr_9465[(0)] = gpio_socket$core$register_client_$_state_machine__6867__auto__);

(statearr_9465[(1)] = (1));

return statearr_9465;
});
var gpio_socket$core$register_client_$_state_machine__6867__auto____1 = (function (state_9451){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9451);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9466){if((e9466 instanceof Object)){
var ex__6870__auto__ = e9466;
var statearr_9467_9508 = state_9451;
(statearr_9467_9508[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9451);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9466;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__9509 = state_9451;
state_9451 = G__9509;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
gpio_socket$core$register_client_$_state_machine__6867__auto__ = function(state_9451){
switch(arguments.length){
case 0:
return gpio_socket$core$register_client_$_state_machine__6867__auto____0.call(this);
case 1:
return gpio_socket$core$register_client_$_state_machine__6867__auto____1.call(this,state_9451);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
gpio_socket$core$register_client_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = gpio_socket$core$register_client_$_state_machine__6867__auto____0;
gpio_socket$core$register_client_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = gpio_socket$core$register_client_$_state_machine__6867__auto____1;
return gpio_socket$core$register_client_$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out))
})();
var state__6933__auto__ = (function (){var statearr_9468 = f__6932__auto__.call(null);
(statearr_9468[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___9501);

return statearr_9468;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___9501,map__9434,map__9434__$1,client,in$,out))
);


var c__6931__auto___9510 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out){
return (function (state_9483){
var state_val_9484 = (state_9483[(1)]);
if((state_val_9484 === (1))){
var state_9483__$1 = state_9483;
var statearr_9485_9511 = state_9483__$1;
(statearr_9485_9511[(2)] = null);

(statearr_9485_9511[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9484 === (2))){
var state_9483__$1 = state_9483;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9483__$1,(4),out);
} else {
if((state_val_9484 === (3))){
var inst_9481 = (state_9483[(2)]);
var state_9483__$1 = state_9483;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9483__$1,inst_9481);
} else {
if((state_val_9484 === (4))){
var inst_9472 = (state_9483[(7)]);
var inst_9471 = (state_9483[(2)]);
var inst_9472__$1 = gpio_socket.utils.throw_error.call(null,inst_9471);
var state_9483__$1 = (function (){var statearr_9486 = state_9483;
(statearr_9486[(7)] = inst_9472__$1);

return statearr_9486;
})();
if(cljs.core.truth_(inst_9472__$1)){
var statearr_9487_9512 = state_9483__$1;
(statearr_9487_9512[(1)] = (5));

} else {
var statearr_9488_9513 = state_9483__$1;
(statearr_9488_9513[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9484 === (5))){
var inst_9472 = (state_9483[(7)]);
var inst_9474 = gpio_socket.core.encode_message.call(null,inst_9472);
var inst_9475 = socket.send(inst_9474);
var state_9483__$1 = (function (){var statearr_9489 = state_9483;
(statearr_9489[(8)] = inst_9475);

return statearr_9489;
})();
var statearr_9490_9514 = state_9483__$1;
(statearr_9490_9514[(2)] = null);

(statearr_9490_9514[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9484 === (6))){
var state_9483__$1 = state_9483;
var statearr_9491_9515 = state_9483__$1;
(statearr_9491_9515[(2)] = null);

(statearr_9491_9515[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9484 === (7))){
var inst_9479 = (state_9483[(2)]);
var state_9483__$1 = state_9483;
var statearr_9492_9516 = state_9483__$1;
(statearr_9492_9516[(2)] = inst_9479);

(statearr_9492_9516[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out))
;
return ((function (switch__6866__auto__,c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out){
return (function() {
var gpio_socket$core$register_client_$_state_machine__6867__auto__ = null;
var gpio_socket$core$register_client_$_state_machine__6867__auto____0 = (function (){
var statearr_9496 = [null,null,null,null,null,null,null,null,null];
(statearr_9496[(0)] = gpio_socket$core$register_client_$_state_machine__6867__auto__);

(statearr_9496[(1)] = (1));

return statearr_9496;
});
var gpio_socket$core$register_client_$_state_machine__6867__auto____1 = (function (state_9483){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9483);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9497){if((e9497 instanceof Object)){
var ex__6870__auto__ = e9497;
var statearr_9498_9517 = state_9483;
(statearr_9498_9517[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9483);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9497;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__9518 = state_9483;
state_9483 = G__9518;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
gpio_socket$core$register_client_$_state_machine__6867__auto__ = function(state_9483){
switch(arguments.length){
case 0:
return gpio_socket$core$register_client_$_state_machine__6867__auto____0.call(this);
case 1:
return gpio_socket$core$register_client_$_state_machine__6867__auto____1.call(this,state_9483);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
gpio_socket$core$register_client_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = gpio_socket$core$register_client_$_state_machine__6867__auto____0;
gpio_socket$core$register_client_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = gpio_socket$core$register_client_$_state_machine__6867__auto____1;
return gpio_socket$core$register_client_$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out))
})();
var state__6933__auto__ = (function (){var statearr_9499 = f__6932__auto__.call(null);
(statearr_9499[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___9510);

return statearr_9499;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___9510,map__9434,map__9434__$1,client,in$,out))
);


socket.on("message",((function (map__9434,map__9434__$1,client,in$,out){
return (function (p1__9366_SHARP_){
return cljs.core.async.put_BANG_.call(null,in$,(function (){try{return gpio_socket.core.parse_message.call(null,p1__9366_SHARP_);
}catch (e9500){if((e9500 instanceof Error)){
var err = e9500;
return cljs.core.async.put_BANG_.call(null,out,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["error","bad syntax"], null));
} else {
throw e9500;

}
}})());
});})(map__9434,map__9434__$1,client,in$,out))
);

socket.on("close",((function (map__9434,map__9434__$1,client,in$,out){
return (function (){
return cljs.core.async.put_BANG_.call(null,in$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"quit","quit",53285210)], null));
});})(map__9434,map__9434__$1,client,in$,out))
);

return cljs.core.swap_BANG_.call(null,gpio_socket.core.clients,cljs.core.conj,client);
});
gpio_socket.core.listen = (function gpio_socket$core$listen(port){
var ws = (new gpio_socket.core.ws.Server({"port": port}));
ws.on("connection",gpio_socket.core.register_client);

return ws;
});
cljs.core.enable_console_print_BANG_.call(null);
gpio_socket.core._main = (function gpio_socket$core$_main(){
var args__5594__auto__ = [];
var len__5587__auto___9520 = arguments.length;
var i__5588__auto___9521 = (0);
while(true){
if((i__5588__auto___9521 < len__5587__auto___9520)){
args__5594__auto__.push((arguments[i__5588__auto___9521]));

var G__9522 = (i__5588__auto___9521 + (1));
i__5588__auto___9521 = G__9522;
continue;
} else {
}
break;
}

var argseq__5595__auto__ = ((((0) < args__5594__auto__.length))?(new cljs.core.IndexedSeq(args__5594__auto__.slice((0)),(0))):null);
return gpio_socket.core._main.cljs$core$IFn$_invoke$arity$variadic(argseq__5595__auto__);
});

gpio_socket.core._main.cljs$core$IFn$_invoke$arity$variadic = (function (args){
var temp__4423__auto__ = cljs.core.first.call(null,args);
if(cljs.core.truth_(temp__4423__auto__)){
var port = temp__4423__auto__;
gpio_socket.core.listen.call(null,port);

return cljs.core.println.call(null,"Listening on port:",port);
} else {
return cljs.core.println.call(null,"Usage: gpio-socket <port>");
}
});

gpio_socket.core._main.cljs$lang$maxFixedArity = (0);

gpio_socket.core._main.cljs$lang$applyTo = (function (seq9519){
return gpio_socket.core._main.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq9519));
});
cljs.core._STAR_main_cli_fn_STAR_ = gpio_socket.core._main;

//# sourceMappingURL=core.js.map