// Compiled by ClojureScript 1.7.48 {:target :nodejs}
goog.provide('gpio_socket.gpio');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('cljs.nodejs');
goog.require('gpio_socket.utils');
gpio_socket.gpio.onoff = require("onoff");
gpio_socket.gpio.writes = cljs.core.async.chan.call(null);
gpio_socket.gpio.changes = cljs.core.async.chan.call(null);
gpio_socket.gpio.errors = cljs.core.async.chan.call(null);
gpio_socket.gpio.changes_mult = cljs.core.async.mult.call(null,gpio_socket.gpio.changes);
gpio_socket.gpio.gpios = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
gpio_socket.gpio.watches = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
gpio_socket.gpio.create = (function gpio_socket$gpio$create(port,direction){
var temp__4423__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,gpio_socket.gpio.gpios),port);
if(cljs.core.truth_(temp__4423__auto__)){
var gpio = temp__4423__auto__;
gpio.setDirection(direction);

return gpio;
} else {
var gpio = (new gpio_socket.gpio.onoff.Gpio(port,direction));
cljs.core.swap_BANG_.call(null,gpio_socket.gpio.gpios,cljs.core.assoc,port,gpio);

return gpio;
}
});
gpio_socket.gpio.watch = (function gpio_socket$gpio$watch(port){
var f = cljs.core.get.call(null,cljs.core.deref.call(null,gpio_socket.gpio.watches),port);
if(cljs.core.truth_(f)){
return null;
} else {
var gpio = gpio_socket.gpio.create.call(null,port,"in");
var f__$1 = ((function (gpio,f){
return (function (err,value){
if(cljs.core.truth_(err)){
return cljs.core.async.put_BANG_.call(null,gpio_socket.gpio.errors,err);
} else {
return cljs.core.async.put_BANG_.call(null,gpio_socket.gpio.changes,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [port,value], null));
}
});})(gpio,f))
;
gpio.setEdge("both");

gpio.watch(f__$1);

return cljs.core.swap_BANG_.call(null,gpio_socket.gpio.watches,cljs.core.assoc,port,f__$1);
}
});
gpio_socket.gpio.unwatch = (function gpio_socket$gpio$unwatch(port){
return null;
});
gpio_socket.gpio.write = (function gpio_socket$gpio$write(port,value){
return cljs.core.async.put_BANG_.call(null,gpio_socket.gpio.writes,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [port,value], null));
});
var c__6931__auto___9240 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___9240){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___9240){
return (function (state_9219){
var state_val_9220 = (state_9219[(1)]);
if((state_val_9220 === (7))){
var inst_9215 = (state_9219[(2)]);
var state_9219__$1 = state_9219;
var statearr_9221_9241 = state_9219__$1;
(statearr_9221_9241[(2)] = inst_9215);

(statearr_9221_9241[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (1))){
var state_9219__$1 = state_9219;
var statearr_9222_9242 = state_9219__$1;
(statearr_9222_9242[(2)] = null);

(statearr_9222_9242[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (4))){
var inst_9193 = (state_9219[(7)]);
var inst_9193__$1 = (state_9219[(2)]);
var state_9219__$1 = (function (){var statearr_9223 = state_9219;
(statearr_9223[(7)] = inst_9193__$1);

return statearr_9223;
})();
if(cljs.core.truth_(inst_9193__$1)){
var statearr_9224_9243 = state_9219__$1;
(statearr_9224_9243[(1)] = (5));

} else {
var statearr_9225_9244 = state_9219__$1;
(statearr_9225_9244[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (6))){
var state_9219__$1 = state_9219;
var statearr_9226_9245 = state_9219__$1;
(statearr_9226_9245[(2)] = null);

(statearr_9226_9245[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (3))){
var inst_9217 = (state_9219[(2)]);
var state_9219__$1 = state_9219;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9219__$1,inst_9217);
} else {
if((state_val_9220 === (12))){
var inst_9208 = (state_9219[(2)]);
var inst_9209 = gpio_socket.utils.throw_error.call(null,inst_9208);
var state_9219__$1 = state_9219;
var statearr_9227_9246 = state_9219__$1;
(statearr_9227_9246[(2)] = inst_9209);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9219__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (2))){
var state_9219__$1 = state_9219;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9219__$1,(4),gpio_socket.gpio.writes);
} else {
if((state_val_9220 === (11))){
var inst_9198 = (state_9219[(8)]);
var inst_9196 = (state_9219[(9)]);
var inst_9197 = (state_9219[(10)]);
var inst_9193 = (state_9219[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_9219,(9),Error,null,(8));
var inst_9205 = (function (){var temp__4425__auto__ = inst_9193;
var vec__9195 = inst_9193;
var port = inst_9196;
var value = inst_9197;
var gpio = inst_9198;
return ((function (temp__4425__auto__,vec__9195,port,value,gpio,inst_9198,inst_9196,inst_9197,inst_9193,_,state_val_9220,c__6931__auto___9240){
return (function (p1__9190_SHARP_){
return gpio.write(value,gpio_socket.utils.chan__GT_cb.call(null,p1__9190_SHARP_));
});
;})(temp__4425__auto__,vec__9195,port,value,gpio,inst_9198,inst_9196,inst_9197,inst_9193,_,state_val_9220,c__6931__auto___9240))
})();
var inst_9206 = gpio_socket.utils.with_chan.call(null,inst_9205);
var state_9219__$1 = state_9219;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9219__$1,(12),inst_9206);
} else {
if((state_val_9220 === (9))){
var inst_9199 = (state_9219[(2)]);
var state_9219__$1 = state_9219;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_9219__$1,(10),gpio_socket.gpio.errors,inst_9199);
} else {
if((state_val_9220 === (5))){
var inst_9196 = (state_9219[(9)]);
var inst_9193 = (state_9219[(7)]);
var inst_9196__$1 = cljs.core.nth.call(null,inst_9193,(0),null);
var inst_9197 = cljs.core.nth.call(null,inst_9193,(1),null);
var inst_9198 = gpio_socket.gpio.create.call(null,inst_9196__$1,"out");
var state_9219__$1 = (function (){var statearr_9228 = state_9219;
(statearr_9228[(8)] = inst_9198);

(statearr_9228[(9)] = inst_9196__$1);

(statearr_9228[(10)] = inst_9197);

return statearr_9228;
})();
var statearr_9229_9247 = state_9219__$1;
(statearr_9229_9247[(2)] = null);

(statearr_9229_9247[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (10))){
var inst_9201 = (state_9219[(2)]);
var state_9219__$1 = state_9219;
var statearr_9230_9248 = state_9219__$1;
(statearr_9230_9248[(2)] = inst_9201);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9219__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9220 === (8))){
var inst_9211 = (state_9219[(2)]);
var state_9219__$1 = (function (){var statearr_9231 = state_9219;
(statearr_9231[(11)] = inst_9211);

return statearr_9231;
})();
var statearr_9232_9249 = state_9219__$1;
(statearr_9232_9249[(2)] = null);

(statearr_9232_9249[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___9240))
;
return ((function (switch__6866__auto__,c__6931__auto___9240){
return (function() {
var gpio_socket$gpio$state_machine__6867__auto__ = null;
var gpio_socket$gpio$state_machine__6867__auto____0 = (function (){
var statearr_9236 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_9236[(0)] = gpio_socket$gpio$state_machine__6867__auto__);

(statearr_9236[(1)] = (1));

return statearr_9236;
});
var gpio_socket$gpio$state_machine__6867__auto____1 = (function (state_9219){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9219);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9237){if((e9237 instanceof Object)){
var ex__6870__auto__ = e9237;
var statearr_9238_9250 = state_9219;
(statearr_9238_9250[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9219);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9237;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__9251 = state_9219;
state_9219 = G__9251;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
gpio_socket$gpio$state_machine__6867__auto__ = function(state_9219){
switch(arguments.length){
case 0:
return gpio_socket$gpio$state_machine__6867__auto____0.call(this);
case 1:
return gpio_socket$gpio$state_machine__6867__auto____1.call(this,state_9219);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
gpio_socket$gpio$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = gpio_socket$gpio$state_machine__6867__auto____0;
gpio_socket$gpio$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = gpio_socket$gpio$state_machine__6867__auto____1;
return gpio_socket$gpio$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___9240))
})();
var state__6933__auto__ = (function (){var statearr_9239 = f__6932__auto__.call(null);
(statearr_9239[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___9240);

return statearr_9239;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___9240))
);

var c__6931__auto___9282 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___9282){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___9282){
return (function (state_9265){
var state_val_9266 = (state_9265[(1)]);
if((state_val_9266 === (1))){
var state_9265__$1 = state_9265;
var statearr_9267_9283 = state_9265__$1;
(statearr_9267_9283[(2)] = null);

(statearr_9267_9283[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9266 === (2))){
var state_9265__$1 = state_9265;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9265__$1,(4),gpio_socket.gpio.errors);
} else {
if((state_val_9266 === (3))){
var inst_9263 = (state_9265[(2)]);
var state_9265__$1 = state_9265;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9265__$1,inst_9263);
} else {
if((state_val_9266 === (4))){
var inst_9255 = (state_9265[(7)]);
var inst_9254 = (state_9265[(2)]);
var inst_9255__$1 = gpio_socket.utils.throw_error.call(null,inst_9254);
var state_9265__$1 = (function (){var statearr_9268 = state_9265;
(statearr_9268[(7)] = inst_9255__$1);

return statearr_9268;
})();
if(cljs.core.truth_(inst_9255__$1)){
var statearr_9269_9284 = state_9265__$1;
(statearr_9269_9284[(1)] = (5));

} else {
var statearr_9270_9285 = state_9265__$1;
(statearr_9270_9285[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9266 === (5))){
var inst_9255 = (state_9265[(7)]);
var inst_9257 = cljs.core.println.call(null,"gpio error:",inst_9255);
var state_9265__$1 = (function (){var statearr_9271 = state_9265;
(statearr_9271[(8)] = inst_9257);

return statearr_9271;
})();
var statearr_9272_9286 = state_9265__$1;
(statearr_9272_9286[(2)] = null);

(statearr_9272_9286[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9266 === (6))){
var state_9265__$1 = state_9265;
var statearr_9273_9287 = state_9265__$1;
(statearr_9273_9287[(2)] = null);

(statearr_9273_9287[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9266 === (7))){
var inst_9261 = (state_9265[(2)]);
var state_9265__$1 = state_9265;
var statearr_9274_9288 = state_9265__$1;
(statearr_9274_9288[(2)] = inst_9261);

(statearr_9274_9288[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__6931__auto___9282))
;
return ((function (switch__6866__auto__,c__6931__auto___9282){
return (function() {
var gpio_socket$gpio$state_machine__6867__auto__ = null;
var gpio_socket$gpio$state_machine__6867__auto____0 = (function (){
var statearr_9278 = [null,null,null,null,null,null,null,null,null];
(statearr_9278[(0)] = gpio_socket$gpio$state_machine__6867__auto__);

(statearr_9278[(1)] = (1));

return statearr_9278;
});
var gpio_socket$gpio$state_machine__6867__auto____1 = (function (state_9265){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9265);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9279){if((e9279 instanceof Object)){
var ex__6870__auto__ = e9279;
var statearr_9280_9289 = state_9265;
(statearr_9280_9289[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9265);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9279;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__9290 = state_9265;
state_9265 = G__9290;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
gpio_socket$gpio$state_machine__6867__auto__ = function(state_9265){
switch(arguments.length){
case 0:
return gpio_socket$gpio$state_machine__6867__auto____0.call(this);
case 1:
return gpio_socket$gpio$state_machine__6867__auto____1.call(this,state_9265);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
gpio_socket$gpio$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = gpio_socket$gpio$state_machine__6867__auto____0;
gpio_socket$gpio$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = gpio_socket$gpio$state_machine__6867__auto____1;
return gpio_socket$gpio$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___9282))
})();
var state__6933__auto__ = (function (){var statearr_9281 = f__6932__auto__.call(null);
(statearr_9281[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___9282);

return statearr_9281;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___9282))
);


//# sourceMappingURL=gpio.js.map