// Compiled by ClojureScript 1.7.48 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(f){
if(typeof cljs.core.async.t9558 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t9558 = (function (fn_handler,f,meta9559){
this.fn_handler = fn_handler;
this.f = f;
this.meta9559 = meta9559;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t9558.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_9560,meta9559__$1){
var self__ = this;
var _9560__$1 = this;
return (new cljs.core.async.t9558(self__.fn_handler,self__.f,meta9559__$1));
});

cljs.core.async.t9558.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_9560){
var self__ = this;
var _9560__$1 = this;
return self__.meta9559;
});

cljs.core.async.t9558.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t9558.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t9558.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t9558.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"fn-handler","fn-handler",648785851,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null)], null)))], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"meta9559","meta9559",-592075039,null)], null);
});

cljs.core.async.t9558.cljs$lang$type = true;

cljs.core.async.t9558.cljs$lang$ctorStr = "cljs.core.async/t9558";

cljs.core.async.t9558.cljs$lang$ctorPrWriter = (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t9558");
});

cljs.core.async.__GT_t9558 = (function cljs$core$async$fn_handler_$___GT_t9558(fn_handler__$1,f__$1,meta9559){
return (new cljs.core.async.t9558(fn_handler__$1,f__$1,meta9559));
});

}

return (new cljs.core.async.t9558(cljs$core$async$fn_handler,f,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 * val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 * buffered, but oldest elements in buffer will be dropped (not
 * transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full.
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || (buff.cljs$core$async$impl$protocols$UnblockingBuffer$)){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 * (filter p) etc or a composition thereof), and an optional exception handler.
 * If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 * transducer is supplied a buffer must be specified. ex-handler must be a
 * fn of one argument - if an exception occurs during transformation it will be called
 * with the thrown value as an argument, and any non-nil return value will be placed
 * in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(){
var args9563 = [];
var len__5587__auto___9566 = arguments.length;
var i__5588__auto___9567 = (0);
while(true){
if((i__5588__auto___9567 < len__5587__auto___9566)){
args9563.push((arguments[i__5588__auto___9567]));

var G__9568 = (i__5588__auto___9567 + (1));
i__5588__auto___9567 = G__9568;
continue;
} else {
}
break;
}

var G__9565 = args9563.length;
switch (G__9565) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args9563.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"buf-or-n","buf-or-n",-1646815050,null)))].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;
/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 * return nil if closed. Will park if nothing is available.
 * Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(){
var args9570 = [];
var len__5587__auto___9573 = arguments.length;
var i__5588__auto___9574 = (0);
while(true){
if((i__5588__auto___9574 < len__5587__auto___9573)){
args9570.push((arguments[i__5588__auto___9574]));

var G__9575 = (i__5588__auto___9574 + (1));
i__5588__auto___9574 = G__9575;
continue;
} else {
}
break;
}

var G__9572 = args9570.length;
switch (G__9572) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args9570.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_9577 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_9577);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_9577,ret){
return (function (){
return fn1.call(null,val_9577);
});})(val_9577,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;
cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 * inside a (go ...) block. Will park if no buffer space is available.
 * Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(){
var args9578 = [];
var len__5587__auto___9581 = arguments.length;
var i__5588__auto___9582 = (0);
while(true){
if((i__5588__auto___9582 < len__5587__auto___9581)){
args9578.push((arguments[i__5588__auto___9582]));

var G__9583 = (i__5588__auto___9582 + (1));
i__5588__auto___9582 = G__9583;
continue;
} else {
}
break;
}

var G__9580 = args9578.length;
switch (G__9580) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args9578.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4423__auto__)){
var ret = temp__4423__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4423__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4423__auto__)){
var retb = temp__4423__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4423__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4423__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;
cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__5432__auto___9585 = n;
var x_9586 = (0);
while(true){
if((x_9586 < n__5432__auto___9585)){
(a[x_9586] = (0));

var G__9587 = (x_9586 + (1));
x_9586 = G__9587;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__9588 = (i + (1));
i = G__9588;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t9592 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t9592 = (function (alt_flag,flag,meta9593){
this.alt_flag = alt_flag;
this.flag = flag;
this.meta9593 = meta9593;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t9592.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_9594,meta9593__$1){
var self__ = this;
var _9594__$1 = this;
return (new cljs.core.async.t9592(self__.alt_flag,self__.flag,meta9593__$1));
});})(flag))
;

cljs.core.async.t9592.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_9594){
var self__ = this;
var _9594__$1 = this;
return self__.meta9593;
});})(flag))
;

cljs.core.async.t9592.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t9592.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t9592.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t9592.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-flag","alt-flag",-1794972754,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(cljs.core.PersistentVector.EMPTY))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta9593","meta9593",1945088865,null)], null);
});})(flag))
;

cljs.core.async.t9592.cljs$lang$type = true;

cljs.core.async.t9592.cljs$lang$ctorStr = "cljs.core.async/t9592";

cljs.core.async.t9592.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t9592");
});})(flag))
;

cljs.core.async.__GT_t9592 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t9592(alt_flag__$1,flag__$1,meta9593){
return (new cljs.core.async.t9592(alt_flag__$1,flag__$1,meta9593));
});})(flag))
;

}

return (new cljs.core.async.t9592(cljs$core$async$alt_flag,flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t9598 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t9598 = (function (alt_handler,flag,cb,meta9599){
this.alt_handler = alt_handler;
this.flag = flag;
this.cb = cb;
this.meta9599 = meta9599;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t9598.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_9600,meta9599__$1){
var self__ = this;
var _9600__$1 = this;
return (new cljs.core.async.t9598(self__.alt_handler,self__.flag,self__.cb,meta9599__$1));
});

cljs.core.async.t9598.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_9600){
var self__ = this;
var _9600__$1 = this;
return self__.meta9599;
});

cljs.core.async.t9598.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t9598.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t9598.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t9598.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"alt-handler","alt-handler",963786170,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"private","private",-558947994),true,new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null)], null)))], null)),new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta9599","meta9599",-567236193,null)], null);
});

cljs.core.async.t9598.cljs$lang$type = true;

cljs.core.async.t9598.cljs$lang$ctorStr = "cljs.core.async/t9598";

cljs.core.async.t9598.cljs$lang$ctorPrWriter = (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t9598");
});

cljs.core.async.__GT_t9598 = (function cljs$core$async$alt_handler_$___GT_t9598(alt_handler__$1,flag__$1,cb__$1,meta9599){
return (new cljs.core.async.t9598(alt_handler__$1,flag__$1,cb__$1,meta9599));
});

}

return (new cljs.core.async.t9598(cljs$core$async$alt_handler,flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__9601_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__9601_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__9602_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__9602_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__4548__auto__ = wport;
if(cljs.core.truth_(or__4548__auto__)){
return or__4548__auto__;
} else {
return port;
}
})()], null));
} else {
var G__9603 = (i + (1));
i = G__9603;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4548__auto__ = ret;
if(cljs.core.truth_(or__4548__auto__)){
return or__4548__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4425__auto__ = (function (){var and__4536__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__4536__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__4536__auto__;
}
})();
if(cljs.core.truth_(temp__4425__auto__)){
var got = temp__4425__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 * [channel-to-put-to val-to-put], in any combination. Takes will be
 * made as if by <!, and puts will be made as if by >!. Unless
 * the :priority option is true, if more than one port operation is
 * ready a non-deterministic choice will be made. If no operation is
 * ready and a :default value is supplied, [default-val :default] will
 * be returned, otherwise alts! will park until the first operation to
 * become ready completes. Returns [val port] of the completed
 * operation, where val is the value taken for takes, and a
 * boolean (true unless already closed, as per put!) for puts.
 * 
 * opts are passed as :key val ... Supported options:
 * 
 * :default val - the value to use if none of the operations are immediately ready
 * :priority true - (default nil) when true, the operations will be tried in order.
 * 
 * Note: there is no guarantee that the port exps or val exprs will be
 * used, nor in what order should they be, so they should not be
 * depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(){
var args__5594__auto__ = [];
var len__5587__auto___9609 = arguments.length;
var i__5588__auto___9610 = (0);
while(true){
if((i__5588__auto___9610 < len__5587__auto___9609)){
args__5594__auto__.push((arguments[i__5588__auto___9610]));

var G__9611 = (i__5588__auto___9610 + (1));
i__5588__auto___9610 = G__9611;
continue;
} else {
}
break;
}

var argseq__5595__auto__ = ((((1) < args__5594__auto__.length))?(new cljs.core.IndexedSeq(args__5594__auto__.slice((1)),(0))):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__5595__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__9606){
var map__9607 = p__9606;
var map__9607__$1 = ((((!((map__9607 == null)))?((((map__9607.cljs$lang$protocol_mask$partition0$ & (64))) || (map__9607.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9607):map__9607);
var opts = map__9607__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq9604){
var G__9605 = cljs.core.first.call(null,seq9604);
var seq9604__$1 = cljs.core.next.call(null,seq9604);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__9605,seq9604__$1);
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(){
var args9612 = [];
var len__5587__auto___9662 = arguments.length;
var i__5588__auto___9663 = (0);
while(true){
if((i__5588__auto___9663 < len__5587__auto___9662)){
args9612.push((arguments[i__5588__auto___9663]));

var G__9664 = (i__5588__auto___9663 + (1));
i__5588__auto___9663 = G__9664;
continue;
} else {
}
break;
}

var G__9614 = args9612.length;
switch (G__9614) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args9612.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__6931__auto___9666 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___9666){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___9666){
return (function (state_9638){
var state_val_9639 = (state_9638[(1)]);
if((state_val_9639 === (7))){
var inst_9634 = (state_9638[(2)]);
var state_9638__$1 = state_9638;
var statearr_9640_9667 = state_9638__$1;
(statearr_9640_9667[(2)] = inst_9634);

(statearr_9640_9667[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (1))){
var state_9638__$1 = state_9638;
var statearr_9641_9668 = state_9638__$1;
(statearr_9641_9668[(2)] = null);

(statearr_9641_9668[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (4))){
var inst_9617 = (state_9638[(7)]);
var inst_9617__$1 = (state_9638[(2)]);
var inst_9618 = (inst_9617__$1 == null);
var state_9638__$1 = (function (){var statearr_9642 = state_9638;
(statearr_9642[(7)] = inst_9617__$1);

return statearr_9642;
})();
if(cljs.core.truth_(inst_9618)){
var statearr_9643_9669 = state_9638__$1;
(statearr_9643_9669[(1)] = (5));

} else {
var statearr_9644_9670 = state_9638__$1;
(statearr_9644_9670[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (13))){
var state_9638__$1 = state_9638;
var statearr_9645_9671 = state_9638__$1;
(statearr_9645_9671[(2)] = null);

(statearr_9645_9671[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (6))){
var inst_9617 = (state_9638[(7)]);
var state_9638__$1 = state_9638;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_9638__$1,(11),to,inst_9617);
} else {
if((state_val_9639 === (3))){
var inst_9636 = (state_9638[(2)]);
var state_9638__$1 = state_9638;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9638__$1,inst_9636);
} else {
if((state_val_9639 === (12))){
var state_9638__$1 = state_9638;
var statearr_9646_9672 = state_9638__$1;
(statearr_9646_9672[(2)] = null);

(statearr_9646_9672[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (2))){
var state_9638__$1 = state_9638;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9638__$1,(4),from);
} else {
if((state_val_9639 === (11))){
var inst_9627 = (state_9638[(2)]);
var state_9638__$1 = state_9638;
if(cljs.core.truth_(inst_9627)){
var statearr_9647_9673 = state_9638__$1;
(statearr_9647_9673[(1)] = (12));

} else {
var statearr_9648_9674 = state_9638__$1;
(statearr_9648_9674[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (9))){
var state_9638__$1 = state_9638;
var statearr_9649_9675 = state_9638__$1;
(statearr_9649_9675[(2)] = null);

(statearr_9649_9675[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (5))){
var state_9638__$1 = state_9638;
if(cljs.core.truth_(close_QMARK_)){
var statearr_9650_9676 = state_9638__$1;
(statearr_9650_9676[(1)] = (8));

} else {
var statearr_9651_9677 = state_9638__$1;
(statearr_9651_9677[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (14))){
var inst_9632 = (state_9638[(2)]);
var state_9638__$1 = state_9638;
var statearr_9652_9678 = state_9638__$1;
(statearr_9652_9678[(2)] = inst_9632);

(statearr_9652_9678[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (10))){
var inst_9624 = (state_9638[(2)]);
var state_9638__$1 = state_9638;
var statearr_9653_9679 = state_9638__$1;
(statearr_9653_9679[(2)] = inst_9624);

(statearr_9653_9679[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9639 === (8))){
var inst_9621 = cljs.core.async.close_BANG_.call(null,to);
var state_9638__$1 = state_9638;
var statearr_9654_9680 = state_9638__$1;
(statearr_9654_9680[(2)] = inst_9621);

(statearr_9654_9680[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___9666))
;
return ((function (switch__6866__auto__,c__6931__auto___9666){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_9658 = [null,null,null,null,null,null,null,null];
(statearr_9658[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_9658[(1)] = (1));

return statearr_9658;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_9638){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9638);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9659){if((e9659 instanceof Object)){
var ex__6870__auto__ = e9659;
var statearr_9660_9681 = state_9638;
(statearr_9660_9681[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9638);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9659;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__9682 = state_9638;
state_9638 = G__9682;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_9638){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_9638);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___9666))
})();
var state__6933__auto__ = (function (){var statearr_9661 = f__6932__auto__.call(null);
(statearr_9661[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___9666);

return statearr_9661;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___9666))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;
cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,cljs.core.list(new cljs.core.Symbol(null,"pos?","pos?",-244377722,null),new cljs.core.Symbol(null,"n","n",-2092305744,null))))].join('')));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__9866){
var vec__9867 = p__9866;
var v = cljs.core.nth.call(null,vec__9867,(0),null);
var p = cljs.core.nth.call(null,vec__9867,(1),null);
var job = vec__9867;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__6931__auto___10049 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results){
return (function (state_9872){
var state_val_9873 = (state_9872[(1)]);
if((state_val_9873 === (1))){
var state_9872__$1 = state_9872;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_9872__$1,(2),res,v);
} else {
if((state_val_9873 === (2))){
var inst_9869 = (state_9872[(2)]);
var inst_9870 = cljs.core.async.close_BANG_.call(null,res);
var state_9872__$1 = (function (){var statearr_9874 = state_9872;
(statearr_9874[(7)] = inst_9869);

return statearr_9874;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9872__$1,inst_9870);
} else {
return null;
}
}
});})(c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results))
;
return ((function (switch__6866__auto__,c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_9878 = [null,null,null,null,null,null,null,null];
(statearr_9878[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__);

(statearr_9878[(1)] = (1));

return statearr_9878;
});
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1 = (function (state_9872){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9872);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9879){if((e9879 instanceof Object)){
var ex__6870__auto__ = e9879;
var statearr_9880_10050 = state_9872;
(statearr_9880_10050[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9872);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9879;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10051 = state_9872;
state_9872 = G__10051;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = function(state_9872){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1.call(this,state_9872);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results))
})();
var state__6933__auto__ = (function (){var statearr_9881 = f__6932__auto__.call(null);
(statearr_9881[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10049);

return statearr_9881;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___10049,res,vec__9867,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__9882){
var vec__9883 = p__9882;
var v = cljs.core.nth.call(null,vec__9883,(0),null);
var p = cljs.core.nth.call(null,vec__9883,(1),null);
var job = vec__9883;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__5432__auto___10052 = n;
var __10053 = (0);
while(true){
if((__10053 < n__5432__auto___10052)){
var G__9884_10054 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__9884_10054) {
case "compute":
var c__6931__auto___10056 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__10053,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (__10053,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function (state_9897){
var state_val_9898 = (state_9897[(1)]);
if((state_val_9898 === (1))){
var state_9897__$1 = state_9897;
var statearr_9899_10057 = state_9897__$1;
(statearr_9899_10057[(2)] = null);

(statearr_9899_10057[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9898 === (2))){
var state_9897__$1 = state_9897;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9897__$1,(4),jobs);
} else {
if((state_val_9898 === (3))){
var inst_9895 = (state_9897[(2)]);
var state_9897__$1 = state_9897;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9897__$1,inst_9895);
} else {
if((state_val_9898 === (4))){
var inst_9887 = (state_9897[(2)]);
var inst_9888 = process.call(null,inst_9887);
var state_9897__$1 = state_9897;
if(cljs.core.truth_(inst_9888)){
var statearr_9900_10058 = state_9897__$1;
(statearr_9900_10058[(1)] = (5));

} else {
var statearr_9901_10059 = state_9897__$1;
(statearr_9901_10059[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9898 === (5))){
var state_9897__$1 = state_9897;
var statearr_9902_10060 = state_9897__$1;
(statearr_9902_10060[(2)] = null);

(statearr_9902_10060[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9898 === (6))){
var state_9897__$1 = state_9897;
var statearr_9903_10061 = state_9897__$1;
(statearr_9903_10061[(2)] = null);

(statearr_9903_10061[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9898 === (7))){
var inst_9893 = (state_9897[(2)]);
var state_9897__$1 = state_9897;
var statearr_9904_10062 = state_9897__$1;
(statearr_9904_10062[(2)] = inst_9893);

(statearr_9904_10062[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__10053,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
;
return ((function (__10053,switch__6866__auto__,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_9908 = [null,null,null,null,null,null,null];
(statearr_9908[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__);

(statearr_9908[(1)] = (1));

return statearr_9908;
});
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1 = (function (state_9897){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9897);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9909){if((e9909 instanceof Object)){
var ex__6870__auto__ = e9909;
var statearr_9910_10063 = state_9897;
(statearr_9910_10063[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9897);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9909;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10064 = state_9897;
state_9897 = G__10064;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = function(state_9897){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1.call(this,state_9897);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__;
})()
;})(__10053,switch__6866__auto__,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
})();
var state__6933__auto__ = (function (){var statearr_9911 = f__6932__auto__.call(null);
(statearr_9911[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10056);

return statearr_9911;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(__10053,c__6931__auto___10056,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
);


break;
case "async":
var c__6931__auto___10065 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__10053,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (__10053,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function (state_9924){
var state_val_9925 = (state_9924[(1)]);
if((state_val_9925 === (1))){
var state_9924__$1 = state_9924;
var statearr_9926_10066 = state_9924__$1;
(statearr_9926_10066[(2)] = null);

(statearr_9926_10066[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9925 === (2))){
var state_9924__$1 = state_9924;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9924__$1,(4),jobs);
} else {
if((state_val_9925 === (3))){
var inst_9922 = (state_9924[(2)]);
var state_9924__$1 = state_9924;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9924__$1,inst_9922);
} else {
if((state_val_9925 === (4))){
var inst_9914 = (state_9924[(2)]);
var inst_9915 = async.call(null,inst_9914);
var state_9924__$1 = state_9924;
if(cljs.core.truth_(inst_9915)){
var statearr_9927_10067 = state_9924__$1;
(statearr_9927_10067[(1)] = (5));

} else {
var statearr_9928_10068 = state_9924__$1;
(statearr_9928_10068[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9925 === (5))){
var state_9924__$1 = state_9924;
var statearr_9929_10069 = state_9924__$1;
(statearr_9929_10069[(2)] = null);

(statearr_9929_10069[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9925 === (6))){
var state_9924__$1 = state_9924;
var statearr_9930_10070 = state_9924__$1;
(statearr_9930_10070[(2)] = null);

(statearr_9930_10070[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9925 === (7))){
var inst_9920 = (state_9924[(2)]);
var state_9924__$1 = state_9924;
var statearr_9931_10071 = state_9924__$1;
(statearr_9931_10071[(2)] = inst_9920);

(statearr_9931_10071[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__10053,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
;
return ((function (__10053,switch__6866__auto__,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_9935 = [null,null,null,null,null,null,null];
(statearr_9935[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__);

(statearr_9935[(1)] = (1));

return statearr_9935;
});
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1 = (function (state_9924){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9924);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9936){if((e9936 instanceof Object)){
var ex__6870__auto__ = e9936;
var statearr_9937_10072 = state_9924;
(statearr_9937_10072[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9924);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9936;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10073 = state_9924;
state_9924 = G__10073;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = function(state_9924){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1.call(this,state_9924);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__;
})()
;})(__10053,switch__6866__auto__,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
})();
var state__6933__auto__ = (function (){var statearr_9938 = f__6932__auto__.call(null);
(statearr_9938[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10065);

return statearr_9938;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(__10053,c__6931__auto___10065,G__9884_10054,n__5432__auto___10052,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__10074 = (__10053 + (1));
__10053 = G__10074;
continue;
} else {
}
break;
}

var c__6931__auto___10075 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___10075,jobs,results,process,async){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___10075,jobs,results,process,async){
return (function (state_9960){
var state_val_9961 = (state_9960[(1)]);
if((state_val_9961 === (1))){
var state_9960__$1 = state_9960;
var statearr_9962_10076 = state_9960__$1;
(statearr_9962_10076[(2)] = null);

(statearr_9962_10076[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9961 === (2))){
var state_9960__$1 = state_9960;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_9960__$1,(4),from);
} else {
if((state_val_9961 === (3))){
var inst_9958 = (state_9960[(2)]);
var state_9960__$1 = state_9960;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_9960__$1,inst_9958);
} else {
if((state_val_9961 === (4))){
var inst_9941 = (state_9960[(7)]);
var inst_9941__$1 = (state_9960[(2)]);
var inst_9942 = (inst_9941__$1 == null);
var state_9960__$1 = (function (){var statearr_9963 = state_9960;
(statearr_9963[(7)] = inst_9941__$1);

return statearr_9963;
})();
if(cljs.core.truth_(inst_9942)){
var statearr_9964_10077 = state_9960__$1;
(statearr_9964_10077[(1)] = (5));

} else {
var statearr_9965_10078 = state_9960__$1;
(statearr_9965_10078[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9961 === (5))){
var inst_9944 = cljs.core.async.close_BANG_.call(null,jobs);
var state_9960__$1 = state_9960;
var statearr_9966_10079 = state_9960__$1;
(statearr_9966_10079[(2)] = inst_9944);

(statearr_9966_10079[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9961 === (6))){
var inst_9941 = (state_9960[(7)]);
var inst_9946 = (state_9960[(8)]);
var inst_9946__$1 = cljs.core.async.chan.call(null,(1));
var inst_9947 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_9948 = [inst_9941,inst_9946__$1];
var inst_9949 = (new cljs.core.PersistentVector(null,2,(5),inst_9947,inst_9948,null));
var state_9960__$1 = (function (){var statearr_9967 = state_9960;
(statearr_9967[(8)] = inst_9946__$1);

return statearr_9967;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_9960__$1,(8),jobs,inst_9949);
} else {
if((state_val_9961 === (7))){
var inst_9956 = (state_9960[(2)]);
var state_9960__$1 = state_9960;
var statearr_9968_10080 = state_9960__$1;
(statearr_9968_10080[(2)] = inst_9956);

(statearr_9968_10080[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_9961 === (8))){
var inst_9946 = (state_9960[(8)]);
var inst_9951 = (state_9960[(2)]);
var state_9960__$1 = (function (){var statearr_9969 = state_9960;
(statearr_9969[(9)] = inst_9951);

return statearr_9969;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_9960__$1,(9),results,inst_9946);
} else {
if((state_val_9961 === (9))){
var inst_9953 = (state_9960[(2)]);
var state_9960__$1 = (function (){var statearr_9970 = state_9960;
(statearr_9970[(10)] = inst_9953);

return statearr_9970;
})();
var statearr_9971_10081 = state_9960__$1;
(statearr_9971_10081[(2)] = null);

(statearr_9971_10081[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___10075,jobs,results,process,async))
;
return ((function (switch__6866__auto__,c__6931__auto___10075,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_9975 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_9975[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__);

(statearr_9975[(1)] = (1));

return statearr_9975;
});
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1 = (function (state_9960){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_9960);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e9976){if((e9976 instanceof Object)){
var ex__6870__auto__ = e9976;
var statearr_9977_10082 = state_9960;
(statearr_9977_10082[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_9960);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e9976;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10083 = state_9960;
state_9960 = G__10083;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = function(state_9960){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1.call(this,state_9960);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___10075,jobs,results,process,async))
})();
var state__6933__auto__ = (function (){var statearr_9978 = f__6932__auto__.call(null);
(statearr_9978[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10075);

return statearr_9978;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___10075,jobs,results,process,async))
);


var c__6931__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto__,jobs,results,process,async){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto__,jobs,results,process,async){
return (function (state_10016){
var state_val_10017 = (state_10016[(1)]);
if((state_val_10017 === (7))){
var inst_10012 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
var statearr_10018_10084 = state_10016__$1;
(statearr_10018_10084[(2)] = inst_10012);

(statearr_10018_10084[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (20))){
var state_10016__$1 = state_10016;
var statearr_10019_10085 = state_10016__$1;
(statearr_10019_10085[(2)] = null);

(statearr_10019_10085[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (1))){
var state_10016__$1 = state_10016;
var statearr_10020_10086 = state_10016__$1;
(statearr_10020_10086[(2)] = null);

(statearr_10020_10086[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (4))){
var inst_9981 = (state_10016[(7)]);
var inst_9981__$1 = (state_10016[(2)]);
var inst_9982 = (inst_9981__$1 == null);
var state_10016__$1 = (function (){var statearr_10021 = state_10016;
(statearr_10021[(7)] = inst_9981__$1);

return statearr_10021;
})();
if(cljs.core.truth_(inst_9982)){
var statearr_10022_10087 = state_10016__$1;
(statearr_10022_10087[(1)] = (5));

} else {
var statearr_10023_10088 = state_10016__$1;
(statearr_10023_10088[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (15))){
var inst_9994 = (state_10016[(8)]);
var state_10016__$1 = state_10016;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10016__$1,(18),to,inst_9994);
} else {
if((state_val_10017 === (21))){
var inst_10007 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
var statearr_10024_10089 = state_10016__$1;
(statearr_10024_10089[(2)] = inst_10007);

(statearr_10024_10089[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (13))){
var inst_10009 = (state_10016[(2)]);
var state_10016__$1 = (function (){var statearr_10025 = state_10016;
(statearr_10025[(9)] = inst_10009);

return statearr_10025;
})();
var statearr_10026_10090 = state_10016__$1;
(statearr_10026_10090[(2)] = null);

(statearr_10026_10090[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (6))){
var inst_9981 = (state_10016[(7)]);
var state_10016__$1 = state_10016;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10016__$1,(11),inst_9981);
} else {
if((state_val_10017 === (17))){
var inst_10002 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
if(cljs.core.truth_(inst_10002)){
var statearr_10027_10091 = state_10016__$1;
(statearr_10027_10091[(1)] = (19));

} else {
var statearr_10028_10092 = state_10016__$1;
(statearr_10028_10092[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (3))){
var inst_10014 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10016__$1,inst_10014);
} else {
if((state_val_10017 === (12))){
var inst_9991 = (state_10016[(10)]);
var state_10016__$1 = state_10016;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10016__$1,(14),inst_9991);
} else {
if((state_val_10017 === (2))){
var state_10016__$1 = state_10016;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10016__$1,(4),results);
} else {
if((state_val_10017 === (19))){
var state_10016__$1 = state_10016;
var statearr_10029_10093 = state_10016__$1;
(statearr_10029_10093[(2)] = null);

(statearr_10029_10093[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (11))){
var inst_9991 = (state_10016[(2)]);
var state_10016__$1 = (function (){var statearr_10030 = state_10016;
(statearr_10030[(10)] = inst_9991);

return statearr_10030;
})();
var statearr_10031_10094 = state_10016__$1;
(statearr_10031_10094[(2)] = null);

(statearr_10031_10094[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (9))){
var state_10016__$1 = state_10016;
var statearr_10032_10095 = state_10016__$1;
(statearr_10032_10095[(2)] = null);

(statearr_10032_10095[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (5))){
var state_10016__$1 = state_10016;
if(cljs.core.truth_(close_QMARK_)){
var statearr_10033_10096 = state_10016__$1;
(statearr_10033_10096[(1)] = (8));

} else {
var statearr_10034_10097 = state_10016__$1;
(statearr_10034_10097[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (14))){
var inst_9996 = (state_10016[(11)]);
var inst_9994 = (state_10016[(8)]);
var inst_9994__$1 = (state_10016[(2)]);
var inst_9995 = (inst_9994__$1 == null);
var inst_9996__$1 = cljs.core.not.call(null,inst_9995);
var state_10016__$1 = (function (){var statearr_10035 = state_10016;
(statearr_10035[(11)] = inst_9996__$1);

(statearr_10035[(8)] = inst_9994__$1);

return statearr_10035;
})();
if(inst_9996__$1){
var statearr_10036_10098 = state_10016__$1;
(statearr_10036_10098[(1)] = (15));

} else {
var statearr_10037_10099 = state_10016__$1;
(statearr_10037_10099[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (16))){
var inst_9996 = (state_10016[(11)]);
var state_10016__$1 = state_10016;
var statearr_10038_10100 = state_10016__$1;
(statearr_10038_10100[(2)] = inst_9996);

(statearr_10038_10100[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (10))){
var inst_9988 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
var statearr_10039_10101 = state_10016__$1;
(statearr_10039_10101[(2)] = inst_9988);

(statearr_10039_10101[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (18))){
var inst_9999 = (state_10016[(2)]);
var state_10016__$1 = state_10016;
var statearr_10040_10102 = state_10016__$1;
(statearr_10040_10102[(2)] = inst_9999);

(statearr_10040_10102[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10017 === (8))){
var inst_9985 = cljs.core.async.close_BANG_.call(null,to);
var state_10016__$1 = state_10016;
var statearr_10041_10103 = state_10016__$1;
(statearr_10041_10103[(2)] = inst_9985);

(statearr_10041_10103[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto__,jobs,results,process,async))
;
return ((function (switch__6866__auto__,c__6931__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_10045 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_10045[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__);

(statearr_10045[(1)] = (1));

return statearr_10045;
});
var cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1 = (function (state_10016){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_10016);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e10046){if((e10046 instanceof Object)){
var ex__6870__auto__ = e10046;
var statearr_10047_10104 = state_10016;
(statearr_10047_10104[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10016);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10046;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10105 = state_10016;
state_10016 = G__10105;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__ = function(state_10016){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1.call(this,state_10016);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto__,jobs,results,process,async))
})();
var state__6933__auto__ = (function (){var statearr_10048 = f__6932__auto__.call(null);
(statearr_10048[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto__);

return statearr_10048;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto__,jobs,results,process,async))
);

return c__6931__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel, subject to the async function af, with parallelism n. af
 * must be a function of two arguments, the first an input value and
 * the second a channel on which to place the result(s). af must close!
 * the channel before returning.  The presumption is that af will
 * return immediately, having launched some asynchronous operation
 * whose completion/callback will manipulate the result channel. Outputs
 * will be returned in order relative to  the inputs. By default, the to
 * channel will be closed when the from channel closes, but can be
 * determined by the close?  parameter. Will stop consuming the from
 * channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(){
var args10106 = [];
var len__5587__auto___10109 = arguments.length;
var i__5588__auto___10110 = (0);
while(true){
if((i__5588__auto___10110 < len__5587__auto___10109)){
args10106.push((arguments[i__5588__auto___10110]));

var G__10111 = (i__5588__auto___10110 + (1));
i__5588__auto___10110 = G__10111;
continue;
} else {
}
break;
}

var G__10108 = args10106.length;
switch (G__10108) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10106.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;
/**
 * Takes elements from the from channel and supplies them to the to
 * channel, subject to the transducer xf, with parallelism n. Because
 * it is parallel, the transducer will be applied independently to each
 * element, not across elements, and may produce zero or more outputs
 * per input.  Outputs will be returned in order relative to the
 * inputs. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes.
 * 
 * Note this is supplied for API compatibility with the Clojure version.
 * Values of N > 1 will not result in actual concurrency in a
 * single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(){
var args10113 = [];
var len__5587__auto___10116 = arguments.length;
var i__5588__auto___10117 = (0);
while(true){
if((i__5588__auto___10117 < len__5587__auto___10116)){
args10113.push((arguments[i__5588__auto___10117]));

var G__10118 = (i__5588__auto___10117 + (1));
i__5588__auto___10117 = G__10118;
continue;
} else {
}
break;
}

var G__10115 = args10113.length;
switch (G__10115) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10113.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;
/**
 * Takes a predicate and a source channel and returns a vector of two
 * channels, the first of which will contain the values for which the
 * predicate returned true, the second those for which it returned
 * false.
 * 
 * The out channels will be unbuffered by default, or two buf-or-ns can
 * be supplied. The channels will close after the source channel has
 * closed.
 */
cljs.core.async.split = (function cljs$core$async$split(){
var args10120 = [];
var len__5587__auto___10173 = arguments.length;
var i__5588__auto___10174 = (0);
while(true){
if((i__5588__auto___10174 < len__5587__auto___10173)){
args10120.push((arguments[i__5588__auto___10174]));

var G__10175 = (i__5588__auto___10174 + (1));
i__5588__auto___10174 = G__10175;
continue;
} else {
}
break;
}

var G__10122 = args10120.length;
switch (G__10122) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10120.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__6931__auto___10177 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___10177,tc,fc){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___10177,tc,fc){
return (function (state_10148){
var state_val_10149 = (state_10148[(1)]);
if((state_val_10149 === (7))){
var inst_10144 = (state_10148[(2)]);
var state_10148__$1 = state_10148;
var statearr_10150_10178 = state_10148__$1;
(statearr_10150_10178[(2)] = inst_10144);

(statearr_10150_10178[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (1))){
var state_10148__$1 = state_10148;
var statearr_10151_10179 = state_10148__$1;
(statearr_10151_10179[(2)] = null);

(statearr_10151_10179[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (4))){
var inst_10125 = (state_10148[(7)]);
var inst_10125__$1 = (state_10148[(2)]);
var inst_10126 = (inst_10125__$1 == null);
var state_10148__$1 = (function (){var statearr_10152 = state_10148;
(statearr_10152[(7)] = inst_10125__$1);

return statearr_10152;
})();
if(cljs.core.truth_(inst_10126)){
var statearr_10153_10180 = state_10148__$1;
(statearr_10153_10180[(1)] = (5));

} else {
var statearr_10154_10181 = state_10148__$1;
(statearr_10154_10181[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (13))){
var state_10148__$1 = state_10148;
var statearr_10155_10182 = state_10148__$1;
(statearr_10155_10182[(2)] = null);

(statearr_10155_10182[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (6))){
var inst_10125 = (state_10148[(7)]);
var inst_10131 = p.call(null,inst_10125);
var state_10148__$1 = state_10148;
if(cljs.core.truth_(inst_10131)){
var statearr_10156_10183 = state_10148__$1;
(statearr_10156_10183[(1)] = (9));

} else {
var statearr_10157_10184 = state_10148__$1;
(statearr_10157_10184[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (3))){
var inst_10146 = (state_10148[(2)]);
var state_10148__$1 = state_10148;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10148__$1,inst_10146);
} else {
if((state_val_10149 === (12))){
var state_10148__$1 = state_10148;
var statearr_10158_10185 = state_10148__$1;
(statearr_10158_10185[(2)] = null);

(statearr_10158_10185[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (2))){
var state_10148__$1 = state_10148;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10148__$1,(4),ch);
} else {
if((state_val_10149 === (11))){
var inst_10125 = (state_10148[(7)]);
var inst_10135 = (state_10148[(2)]);
var state_10148__$1 = state_10148;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10148__$1,(8),inst_10135,inst_10125);
} else {
if((state_val_10149 === (9))){
var state_10148__$1 = state_10148;
var statearr_10159_10186 = state_10148__$1;
(statearr_10159_10186[(2)] = tc);

(statearr_10159_10186[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (5))){
var inst_10128 = cljs.core.async.close_BANG_.call(null,tc);
var inst_10129 = cljs.core.async.close_BANG_.call(null,fc);
var state_10148__$1 = (function (){var statearr_10160 = state_10148;
(statearr_10160[(8)] = inst_10128);

return statearr_10160;
})();
var statearr_10161_10187 = state_10148__$1;
(statearr_10161_10187[(2)] = inst_10129);

(statearr_10161_10187[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (14))){
var inst_10142 = (state_10148[(2)]);
var state_10148__$1 = state_10148;
var statearr_10162_10188 = state_10148__$1;
(statearr_10162_10188[(2)] = inst_10142);

(statearr_10162_10188[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (10))){
var state_10148__$1 = state_10148;
var statearr_10163_10189 = state_10148__$1;
(statearr_10163_10189[(2)] = fc);

(statearr_10163_10189[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10149 === (8))){
var inst_10137 = (state_10148[(2)]);
var state_10148__$1 = state_10148;
if(cljs.core.truth_(inst_10137)){
var statearr_10164_10190 = state_10148__$1;
(statearr_10164_10190[(1)] = (12));

} else {
var statearr_10165_10191 = state_10148__$1;
(statearr_10165_10191[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___10177,tc,fc))
;
return ((function (switch__6866__auto__,c__6931__auto___10177,tc,fc){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_10169 = [null,null,null,null,null,null,null,null,null];
(statearr_10169[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_10169[(1)] = (1));

return statearr_10169;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_10148){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_10148);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e10170){if((e10170 instanceof Object)){
var ex__6870__auto__ = e10170;
var statearr_10171_10192 = state_10148;
(statearr_10171_10192[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10148);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10170;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10193 = state_10148;
state_10148 = G__10193;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_10148){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_10148);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___10177,tc,fc))
})();
var state__6933__auto__ = (function (){var statearr_10172 = f__6932__auto__.call(null);
(statearr_10172[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10177);

return statearr_10172;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___10177,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;
/**
 * f should be a function of 2 arguments. Returns a channel containing
 * the single result of applying f to init and the first item from the
 * channel, then applying f to that result and the 2nd item, etc. If
 * the channel closes without yielding items, returns init and f is not
 * called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__6931__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto__){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto__){
return (function (state_10240){
var state_val_10241 = (state_10240[(1)]);
if((state_val_10241 === (1))){
var inst_10226 = init;
var state_10240__$1 = (function (){var statearr_10242 = state_10240;
(statearr_10242[(7)] = inst_10226);

return statearr_10242;
})();
var statearr_10243_10258 = state_10240__$1;
(statearr_10243_10258[(2)] = null);

(statearr_10243_10258[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10241 === (2))){
var state_10240__$1 = state_10240;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10240__$1,(4),ch);
} else {
if((state_val_10241 === (3))){
var inst_10238 = (state_10240[(2)]);
var state_10240__$1 = state_10240;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10240__$1,inst_10238);
} else {
if((state_val_10241 === (4))){
var inst_10229 = (state_10240[(8)]);
var inst_10229__$1 = (state_10240[(2)]);
var inst_10230 = (inst_10229__$1 == null);
var state_10240__$1 = (function (){var statearr_10244 = state_10240;
(statearr_10244[(8)] = inst_10229__$1);

return statearr_10244;
})();
if(cljs.core.truth_(inst_10230)){
var statearr_10245_10259 = state_10240__$1;
(statearr_10245_10259[(1)] = (5));

} else {
var statearr_10246_10260 = state_10240__$1;
(statearr_10246_10260[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10241 === (5))){
var inst_10226 = (state_10240[(7)]);
var state_10240__$1 = state_10240;
var statearr_10247_10261 = state_10240__$1;
(statearr_10247_10261[(2)] = inst_10226);

(statearr_10247_10261[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10241 === (6))){
var inst_10229 = (state_10240[(8)]);
var inst_10226 = (state_10240[(7)]);
var inst_10233 = f.call(null,inst_10226,inst_10229);
var inst_10226__$1 = inst_10233;
var state_10240__$1 = (function (){var statearr_10248 = state_10240;
(statearr_10248[(7)] = inst_10226__$1);

return statearr_10248;
})();
var statearr_10249_10262 = state_10240__$1;
(statearr_10249_10262[(2)] = null);

(statearr_10249_10262[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10241 === (7))){
var inst_10236 = (state_10240[(2)]);
var state_10240__$1 = state_10240;
var statearr_10250_10263 = state_10240__$1;
(statearr_10250_10263[(2)] = inst_10236);

(statearr_10250_10263[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__6931__auto__))
;
return ((function (switch__6866__auto__,c__6931__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__6867__auto__ = null;
var cljs$core$async$reduce_$_state_machine__6867__auto____0 = (function (){
var statearr_10254 = [null,null,null,null,null,null,null,null,null];
(statearr_10254[(0)] = cljs$core$async$reduce_$_state_machine__6867__auto__);

(statearr_10254[(1)] = (1));

return statearr_10254;
});
var cljs$core$async$reduce_$_state_machine__6867__auto____1 = (function (state_10240){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_10240);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e10255){if((e10255 instanceof Object)){
var ex__6870__auto__ = e10255;
var statearr_10256_10264 = state_10240;
(statearr_10256_10264[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10240);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10255;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10265 = state_10240;
state_10240 = G__10265;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__6867__auto__ = function(state_10240){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__6867__auto____1.call(this,state_10240);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__6867__auto____0;
cljs$core$async$reduce_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__6867__auto____1;
return cljs$core$async$reduce_$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto__))
})();
var state__6933__auto__ = (function (){var statearr_10257 = f__6932__auto__.call(null);
(statearr_10257[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto__);

return statearr_10257;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto__))
);

return c__6931__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 * By default the channel will be closed after the items are copied,
 * but can be determined by the close? parameter.
 * 
 * Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(){
var args10266 = [];
var len__5587__auto___10318 = arguments.length;
var i__5588__auto___10319 = (0);
while(true){
if((i__5588__auto___10319 < len__5587__auto___10318)){
args10266.push((arguments[i__5588__auto___10319]));

var G__10320 = (i__5588__auto___10319 + (1));
i__5588__auto___10319 = G__10320;
continue;
} else {
}
break;
}

var G__10268 = args10266.length;
switch (G__10268) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10266.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__6931__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto__){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto__){
return (function (state_10293){
var state_val_10294 = (state_10293[(1)]);
if((state_val_10294 === (7))){
var inst_10275 = (state_10293[(2)]);
var state_10293__$1 = state_10293;
var statearr_10295_10322 = state_10293__$1;
(statearr_10295_10322[(2)] = inst_10275);

(statearr_10295_10322[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (1))){
var inst_10269 = cljs.core.seq.call(null,coll);
var inst_10270 = inst_10269;
var state_10293__$1 = (function (){var statearr_10296 = state_10293;
(statearr_10296[(7)] = inst_10270);

return statearr_10296;
})();
var statearr_10297_10323 = state_10293__$1;
(statearr_10297_10323[(2)] = null);

(statearr_10297_10323[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (4))){
var inst_10270 = (state_10293[(7)]);
var inst_10273 = cljs.core.first.call(null,inst_10270);
var state_10293__$1 = state_10293;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_10293__$1,(7),ch,inst_10273);
} else {
if((state_val_10294 === (13))){
var inst_10287 = (state_10293[(2)]);
var state_10293__$1 = state_10293;
var statearr_10298_10324 = state_10293__$1;
(statearr_10298_10324[(2)] = inst_10287);

(statearr_10298_10324[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (6))){
var inst_10278 = (state_10293[(2)]);
var state_10293__$1 = state_10293;
if(cljs.core.truth_(inst_10278)){
var statearr_10299_10325 = state_10293__$1;
(statearr_10299_10325[(1)] = (8));

} else {
var statearr_10300_10326 = state_10293__$1;
(statearr_10300_10326[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (3))){
var inst_10291 = (state_10293[(2)]);
var state_10293__$1 = state_10293;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10293__$1,inst_10291);
} else {
if((state_val_10294 === (12))){
var state_10293__$1 = state_10293;
var statearr_10301_10327 = state_10293__$1;
(statearr_10301_10327[(2)] = null);

(statearr_10301_10327[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (2))){
var inst_10270 = (state_10293[(7)]);
var state_10293__$1 = state_10293;
if(cljs.core.truth_(inst_10270)){
var statearr_10302_10328 = state_10293__$1;
(statearr_10302_10328[(1)] = (4));

} else {
var statearr_10303_10329 = state_10293__$1;
(statearr_10303_10329[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (11))){
var inst_10284 = cljs.core.async.close_BANG_.call(null,ch);
var state_10293__$1 = state_10293;
var statearr_10304_10330 = state_10293__$1;
(statearr_10304_10330[(2)] = inst_10284);

(statearr_10304_10330[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (9))){
var state_10293__$1 = state_10293;
if(cljs.core.truth_(close_QMARK_)){
var statearr_10305_10331 = state_10293__$1;
(statearr_10305_10331[(1)] = (11));

} else {
var statearr_10306_10332 = state_10293__$1;
(statearr_10306_10332[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (5))){
var inst_10270 = (state_10293[(7)]);
var state_10293__$1 = state_10293;
var statearr_10307_10333 = state_10293__$1;
(statearr_10307_10333[(2)] = inst_10270);

(statearr_10307_10333[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (10))){
var inst_10289 = (state_10293[(2)]);
var state_10293__$1 = state_10293;
var statearr_10308_10334 = state_10293__$1;
(statearr_10308_10334[(2)] = inst_10289);

(statearr_10308_10334[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10294 === (8))){
var inst_10270 = (state_10293[(7)]);
var inst_10280 = cljs.core.next.call(null,inst_10270);
var inst_10270__$1 = inst_10280;
var state_10293__$1 = (function (){var statearr_10309 = state_10293;
(statearr_10309[(7)] = inst_10270__$1);

return statearr_10309;
})();
var statearr_10310_10335 = state_10293__$1;
(statearr_10310_10335[(2)] = null);

(statearr_10310_10335[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto__))
;
return ((function (switch__6866__auto__,c__6931__auto__){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_10314 = [null,null,null,null,null,null,null,null];
(statearr_10314[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_10314[(1)] = (1));

return statearr_10314;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_10293){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_10293);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e10315){if((e10315 instanceof Object)){
var ex__6870__auto__ = e10315;
var statearr_10316_10336 = state_10293;
(statearr_10316_10336[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10293);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10315;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10337 = state_10293;
state_10293 = G__10337;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_10293){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_10293);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto__))
})();
var state__6933__auto__ = (function (){var statearr_10317 = f__6932__auto__.call(null);
(statearr_10317[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto__);

return statearr_10317;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto__))
);

return c__6931__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;
/**
 * Creates and returns a channel which contains the contents of coll,
 * closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

cljs.core.async.Mux = {};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__5184__auto__ = (((_ == null))?null:_);
var m__5185__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,_);
} else {
var m__5185__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


cljs.core.async.Mult = {};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__5185__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,ch);
} else {
var m__5185__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m);
} else {
var m__5185__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 * containing copies of the channel can be created with 'tap', and
 * detached with 'untap'.
 * 
 * Each item is distributed to all taps in parallel and synchronously,
 * i.e. each tap must accept before the next item is distributed. Use
 * buffering/windowing to prevent slow taps from holding up the mult.
 * 
 * Items received when there are no taps get dropped.
 * 
 * If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t10563 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t10563 = (function (mult,ch,cs,meta10564){
this.mult = mult;
this.ch = ch;
this.cs = cs;
this.meta10564 = meta10564;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t10563.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_10565,meta10564__$1){
var self__ = this;
var _10565__$1 = this;
return (new cljs.core.async.t10563(self__.mult,self__.ch,self__.cs,meta10564__$1));
});})(cs))
;

cljs.core.async.t10563.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_10565){
var self__ = this;
var _10565__$1 = this;
return self__.meta10564;
});})(cs))
;

cljs.core.async.t10563.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t10563.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t10563.prototype.cljs$core$async$Mult$ = true;

cljs.core.async.t10563.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t10563.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t10563.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t10563.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"mult","mult",-1187640995,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mult(iple) of the supplied channel. Channels\n  containing copies of the channel can be created with 'tap', and\n  detached with 'untap'.\n\n  Each item is distributed to all taps in parallel and synchronously,\n  i.e. each tap must accept before the next item is distributed. Use\n  buffering/windowing to prevent slow taps from holding up the mult.\n\n  Items received when there are no taps get dropped.\n\n  If a tap puts to a closed channel, it will be removed from the mult."], null)),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta10564","meta10564",570855736,null)], null);
});})(cs))
;

cljs.core.async.t10563.cljs$lang$type = true;

cljs.core.async.t10563.cljs$lang$ctorStr = "cljs.core.async/t10563";

cljs.core.async.t10563.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t10563");
});})(cs))
;

cljs.core.async.__GT_t10563 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t10563(mult__$1,ch__$1,cs__$1,meta10564){
return (new cljs.core.async.t10563(mult__$1,ch__$1,cs__$1,meta10564));
});})(cs))
;

}

return (new cljs.core.async.t10563(cljs$core$async$mult,ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__6931__auto___10784 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___10784,cs,m,dchan,dctr,done){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___10784,cs,m,dchan,dctr,done){
return (function (state_10696){
var state_val_10697 = (state_10696[(1)]);
if((state_val_10697 === (7))){
var inst_10692 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10698_10785 = state_10696__$1;
(statearr_10698_10785[(2)] = inst_10692);

(statearr_10698_10785[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (20))){
var inst_10597 = (state_10696[(7)]);
var inst_10607 = cljs.core.first.call(null,inst_10597);
var inst_10608 = cljs.core.nth.call(null,inst_10607,(0),null);
var inst_10609 = cljs.core.nth.call(null,inst_10607,(1),null);
var state_10696__$1 = (function (){var statearr_10699 = state_10696;
(statearr_10699[(8)] = inst_10608);

return statearr_10699;
})();
if(cljs.core.truth_(inst_10609)){
var statearr_10700_10786 = state_10696__$1;
(statearr_10700_10786[(1)] = (22));

} else {
var statearr_10701_10787 = state_10696__$1;
(statearr_10701_10787[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (27))){
var inst_10644 = (state_10696[(9)]);
var inst_10568 = (state_10696[(10)]);
var inst_10637 = (state_10696[(11)]);
var inst_10639 = (state_10696[(12)]);
var inst_10644__$1 = cljs.core._nth.call(null,inst_10637,inst_10639);
var inst_10645 = cljs.core.async.put_BANG_.call(null,inst_10644__$1,inst_10568,done);
var state_10696__$1 = (function (){var statearr_10702 = state_10696;
(statearr_10702[(9)] = inst_10644__$1);

return statearr_10702;
})();
if(cljs.core.truth_(inst_10645)){
var statearr_10703_10788 = state_10696__$1;
(statearr_10703_10788[(1)] = (30));

} else {
var statearr_10704_10789 = state_10696__$1;
(statearr_10704_10789[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (1))){
var state_10696__$1 = state_10696;
var statearr_10705_10790 = state_10696__$1;
(statearr_10705_10790[(2)] = null);

(statearr_10705_10790[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (24))){
var inst_10597 = (state_10696[(7)]);
var inst_10614 = (state_10696[(2)]);
var inst_10615 = cljs.core.next.call(null,inst_10597);
var inst_10577 = inst_10615;
var inst_10578 = null;
var inst_10579 = (0);
var inst_10580 = (0);
var state_10696__$1 = (function (){var statearr_10706 = state_10696;
(statearr_10706[(13)] = inst_10579);

(statearr_10706[(14)] = inst_10580);

(statearr_10706[(15)] = inst_10578);

(statearr_10706[(16)] = inst_10577);

(statearr_10706[(17)] = inst_10614);

return statearr_10706;
})();
var statearr_10707_10791 = state_10696__$1;
(statearr_10707_10791[(2)] = null);

(statearr_10707_10791[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (39))){
var state_10696__$1 = state_10696;
var statearr_10711_10792 = state_10696__$1;
(statearr_10711_10792[(2)] = null);

(statearr_10711_10792[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (4))){
var inst_10568 = (state_10696[(10)]);
var inst_10568__$1 = (state_10696[(2)]);
var inst_10569 = (inst_10568__$1 == null);
var state_10696__$1 = (function (){var statearr_10712 = state_10696;
(statearr_10712[(10)] = inst_10568__$1);

return statearr_10712;
})();
if(cljs.core.truth_(inst_10569)){
var statearr_10713_10793 = state_10696__$1;
(statearr_10713_10793[(1)] = (5));

} else {
var statearr_10714_10794 = state_10696__$1;
(statearr_10714_10794[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (15))){
var inst_10579 = (state_10696[(13)]);
var inst_10580 = (state_10696[(14)]);
var inst_10578 = (state_10696[(15)]);
var inst_10577 = (state_10696[(16)]);
var inst_10593 = (state_10696[(2)]);
var inst_10594 = (inst_10580 + (1));
var tmp10708 = inst_10579;
var tmp10709 = inst_10578;
var tmp10710 = inst_10577;
var inst_10577__$1 = tmp10710;
var inst_10578__$1 = tmp10709;
var inst_10579__$1 = tmp10708;
var inst_10580__$1 = inst_10594;
var state_10696__$1 = (function (){var statearr_10715 = state_10696;
(statearr_10715[(18)] = inst_10593);

(statearr_10715[(13)] = inst_10579__$1);

(statearr_10715[(14)] = inst_10580__$1);

(statearr_10715[(15)] = inst_10578__$1);

(statearr_10715[(16)] = inst_10577__$1);

return statearr_10715;
})();
var statearr_10716_10795 = state_10696__$1;
(statearr_10716_10795[(2)] = null);

(statearr_10716_10795[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (21))){
var inst_10618 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10720_10796 = state_10696__$1;
(statearr_10720_10796[(2)] = inst_10618);

(statearr_10720_10796[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (31))){
var inst_10644 = (state_10696[(9)]);
var inst_10648 = done.call(null,null);
var inst_10649 = cljs.core.async.untap_STAR_.call(null,m,inst_10644);
var state_10696__$1 = (function (){var statearr_10721 = state_10696;
(statearr_10721[(19)] = inst_10648);

return statearr_10721;
})();
var statearr_10722_10797 = state_10696__$1;
(statearr_10722_10797[(2)] = inst_10649);

(statearr_10722_10797[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (32))){
var inst_10637 = (state_10696[(11)]);
var inst_10638 = (state_10696[(20)]);
var inst_10639 = (state_10696[(12)]);
var inst_10636 = (state_10696[(21)]);
var inst_10651 = (state_10696[(2)]);
var inst_10652 = (inst_10639 + (1));
var tmp10717 = inst_10637;
var tmp10718 = inst_10638;
var tmp10719 = inst_10636;
var inst_10636__$1 = tmp10719;
var inst_10637__$1 = tmp10717;
var inst_10638__$1 = tmp10718;
var inst_10639__$1 = inst_10652;
var state_10696__$1 = (function (){var statearr_10723 = state_10696;
(statearr_10723[(11)] = inst_10637__$1);

(statearr_10723[(22)] = inst_10651);

(statearr_10723[(20)] = inst_10638__$1);

(statearr_10723[(12)] = inst_10639__$1);

(statearr_10723[(21)] = inst_10636__$1);

return statearr_10723;
})();
var statearr_10724_10798 = state_10696__$1;
(statearr_10724_10798[(2)] = null);

(statearr_10724_10798[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (40))){
var inst_10664 = (state_10696[(23)]);
var inst_10668 = done.call(null,null);
var inst_10669 = cljs.core.async.untap_STAR_.call(null,m,inst_10664);
var state_10696__$1 = (function (){var statearr_10725 = state_10696;
(statearr_10725[(24)] = inst_10668);

return statearr_10725;
})();
var statearr_10726_10799 = state_10696__$1;
(statearr_10726_10799[(2)] = inst_10669);

(statearr_10726_10799[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (33))){
var inst_10655 = (state_10696[(25)]);
var inst_10657 = cljs.core.chunked_seq_QMARK_.call(null,inst_10655);
var state_10696__$1 = state_10696;
if(inst_10657){
var statearr_10727_10800 = state_10696__$1;
(statearr_10727_10800[(1)] = (36));

} else {
var statearr_10728_10801 = state_10696__$1;
(statearr_10728_10801[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (13))){
var inst_10587 = (state_10696[(26)]);
var inst_10590 = cljs.core.async.close_BANG_.call(null,inst_10587);
var state_10696__$1 = state_10696;
var statearr_10729_10802 = state_10696__$1;
(statearr_10729_10802[(2)] = inst_10590);

(statearr_10729_10802[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (22))){
var inst_10608 = (state_10696[(8)]);
var inst_10611 = cljs.core.async.close_BANG_.call(null,inst_10608);
var state_10696__$1 = state_10696;
var statearr_10730_10803 = state_10696__$1;
(statearr_10730_10803[(2)] = inst_10611);

(statearr_10730_10803[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (36))){
var inst_10655 = (state_10696[(25)]);
var inst_10659 = cljs.core.chunk_first.call(null,inst_10655);
var inst_10660 = cljs.core.chunk_rest.call(null,inst_10655);
var inst_10661 = cljs.core.count.call(null,inst_10659);
var inst_10636 = inst_10660;
var inst_10637 = inst_10659;
var inst_10638 = inst_10661;
var inst_10639 = (0);
var state_10696__$1 = (function (){var statearr_10731 = state_10696;
(statearr_10731[(11)] = inst_10637);

(statearr_10731[(20)] = inst_10638);

(statearr_10731[(12)] = inst_10639);

(statearr_10731[(21)] = inst_10636);

return statearr_10731;
})();
var statearr_10732_10804 = state_10696__$1;
(statearr_10732_10804[(2)] = null);

(statearr_10732_10804[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (41))){
var inst_10655 = (state_10696[(25)]);
var inst_10671 = (state_10696[(2)]);
var inst_10672 = cljs.core.next.call(null,inst_10655);
var inst_10636 = inst_10672;
var inst_10637 = null;
var inst_10638 = (0);
var inst_10639 = (0);
var state_10696__$1 = (function (){var statearr_10733 = state_10696;
(statearr_10733[(27)] = inst_10671);

(statearr_10733[(11)] = inst_10637);

(statearr_10733[(20)] = inst_10638);

(statearr_10733[(12)] = inst_10639);

(statearr_10733[(21)] = inst_10636);

return statearr_10733;
})();
var statearr_10734_10805 = state_10696__$1;
(statearr_10734_10805[(2)] = null);

(statearr_10734_10805[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (43))){
var state_10696__$1 = state_10696;
var statearr_10735_10806 = state_10696__$1;
(statearr_10735_10806[(2)] = null);

(statearr_10735_10806[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (29))){
var inst_10680 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10736_10807 = state_10696__$1;
(statearr_10736_10807[(2)] = inst_10680);

(statearr_10736_10807[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (44))){
var inst_10689 = (state_10696[(2)]);
var state_10696__$1 = (function (){var statearr_10737 = state_10696;
(statearr_10737[(28)] = inst_10689);

return statearr_10737;
})();
var statearr_10738_10808 = state_10696__$1;
(statearr_10738_10808[(2)] = null);

(statearr_10738_10808[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (6))){
var inst_10628 = (state_10696[(29)]);
var inst_10627 = cljs.core.deref.call(null,cs);
var inst_10628__$1 = cljs.core.keys.call(null,inst_10627);
var inst_10629 = cljs.core.count.call(null,inst_10628__$1);
var inst_10630 = cljs.core.reset_BANG_.call(null,dctr,inst_10629);
var inst_10635 = cljs.core.seq.call(null,inst_10628__$1);
var inst_10636 = inst_10635;
var inst_10637 = null;
var inst_10638 = (0);
var inst_10639 = (0);
var state_10696__$1 = (function (){var statearr_10739 = state_10696;
(statearr_10739[(29)] = inst_10628__$1);

(statearr_10739[(30)] = inst_10630);

(statearr_10739[(11)] = inst_10637);

(statearr_10739[(20)] = inst_10638);

(statearr_10739[(12)] = inst_10639);

(statearr_10739[(21)] = inst_10636);

return statearr_10739;
})();
var statearr_10740_10809 = state_10696__$1;
(statearr_10740_10809[(2)] = null);

(statearr_10740_10809[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (28))){
var inst_10655 = (state_10696[(25)]);
var inst_10636 = (state_10696[(21)]);
var inst_10655__$1 = cljs.core.seq.call(null,inst_10636);
var state_10696__$1 = (function (){var statearr_10741 = state_10696;
(statearr_10741[(25)] = inst_10655__$1);

return statearr_10741;
})();
if(inst_10655__$1){
var statearr_10742_10810 = state_10696__$1;
(statearr_10742_10810[(1)] = (33));

} else {
var statearr_10743_10811 = state_10696__$1;
(statearr_10743_10811[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (25))){
var inst_10638 = (state_10696[(20)]);
var inst_10639 = (state_10696[(12)]);
var inst_10641 = (inst_10639 < inst_10638);
var inst_10642 = inst_10641;
var state_10696__$1 = state_10696;
if(cljs.core.truth_(inst_10642)){
var statearr_10744_10812 = state_10696__$1;
(statearr_10744_10812[(1)] = (27));

} else {
var statearr_10745_10813 = state_10696__$1;
(statearr_10745_10813[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (34))){
var state_10696__$1 = state_10696;
var statearr_10746_10814 = state_10696__$1;
(statearr_10746_10814[(2)] = null);

(statearr_10746_10814[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (17))){
var state_10696__$1 = state_10696;
var statearr_10747_10815 = state_10696__$1;
(statearr_10747_10815[(2)] = null);

(statearr_10747_10815[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (3))){
var inst_10694 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_10696__$1,inst_10694);
} else {
if((state_val_10697 === (12))){
var inst_10623 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10748_10816 = state_10696__$1;
(statearr_10748_10816[(2)] = inst_10623);

(statearr_10748_10816[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (2))){
var state_10696__$1 = state_10696;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10696__$1,(4),ch);
} else {
if((state_val_10697 === (23))){
var state_10696__$1 = state_10696;
var statearr_10749_10817 = state_10696__$1;
(statearr_10749_10817[(2)] = null);

(statearr_10749_10817[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (35))){
var inst_10678 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10750_10818 = state_10696__$1;
(statearr_10750_10818[(2)] = inst_10678);

(statearr_10750_10818[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (19))){
var inst_10597 = (state_10696[(7)]);
var inst_10601 = cljs.core.chunk_first.call(null,inst_10597);
var inst_10602 = cljs.core.chunk_rest.call(null,inst_10597);
var inst_10603 = cljs.core.count.call(null,inst_10601);
var inst_10577 = inst_10602;
var inst_10578 = inst_10601;
var inst_10579 = inst_10603;
var inst_10580 = (0);
var state_10696__$1 = (function (){var statearr_10751 = state_10696;
(statearr_10751[(13)] = inst_10579);

(statearr_10751[(14)] = inst_10580);

(statearr_10751[(15)] = inst_10578);

(statearr_10751[(16)] = inst_10577);

return statearr_10751;
})();
var statearr_10752_10819 = state_10696__$1;
(statearr_10752_10819[(2)] = null);

(statearr_10752_10819[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (11))){
var inst_10597 = (state_10696[(7)]);
var inst_10577 = (state_10696[(16)]);
var inst_10597__$1 = cljs.core.seq.call(null,inst_10577);
var state_10696__$1 = (function (){var statearr_10753 = state_10696;
(statearr_10753[(7)] = inst_10597__$1);

return statearr_10753;
})();
if(inst_10597__$1){
var statearr_10754_10820 = state_10696__$1;
(statearr_10754_10820[(1)] = (16));

} else {
var statearr_10755_10821 = state_10696__$1;
(statearr_10755_10821[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (9))){
var inst_10625 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10756_10822 = state_10696__$1;
(statearr_10756_10822[(2)] = inst_10625);

(statearr_10756_10822[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (5))){
var inst_10575 = cljs.core.deref.call(null,cs);
var inst_10576 = cljs.core.seq.call(null,inst_10575);
var inst_10577 = inst_10576;
var inst_10578 = null;
var inst_10579 = (0);
var inst_10580 = (0);
var state_10696__$1 = (function (){var statearr_10757 = state_10696;
(statearr_10757[(13)] = inst_10579);

(statearr_10757[(14)] = inst_10580);

(statearr_10757[(15)] = inst_10578);

(statearr_10757[(16)] = inst_10577);

return statearr_10757;
})();
var statearr_10758_10823 = state_10696__$1;
(statearr_10758_10823[(2)] = null);

(statearr_10758_10823[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (14))){
var state_10696__$1 = state_10696;
var statearr_10759_10824 = state_10696__$1;
(statearr_10759_10824[(2)] = null);

(statearr_10759_10824[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (45))){
var inst_10686 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10760_10825 = state_10696__$1;
(statearr_10760_10825[(2)] = inst_10686);

(statearr_10760_10825[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (26))){
var inst_10628 = (state_10696[(29)]);
var inst_10682 = (state_10696[(2)]);
var inst_10683 = cljs.core.seq.call(null,inst_10628);
var state_10696__$1 = (function (){var statearr_10761 = state_10696;
(statearr_10761[(31)] = inst_10682);

return statearr_10761;
})();
if(inst_10683){
var statearr_10762_10826 = state_10696__$1;
(statearr_10762_10826[(1)] = (42));

} else {
var statearr_10763_10827 = state_10696__$1;
(statearr_10763_10827[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (16))){
var inst_10597 = (state_10696[(7)]);
var inst_10599 = cljs.core.chunked_seq_QMARK_.call(null,inst_10597);
var state_10696__$1 = state_10696;
if(inst_10599){
var statearr_10764_10828 = state_10696__$1;
(statearr_10764_10828[(1)] = (19));

} else {
var statearr_10765_10829 = state_10696__$1;
(statearr_10765_10829[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (38))){
var inst_10675 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10766_10830 = state_10696__$1;
(statearr_10766_10830[(2)] = inst_10675);

(statearr_10766_10830[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (30))){
var state_10696__$1 = state_10696;
var statearr_10767_10831 = state_10696__$1;
(statearr_10767_10831[(2)] = null);

(statearr_10767_10831[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (10))){
var inst_10580 = (state_10696[(14)]);
var inst_10578 = (state_10696[(15)]);
var inst_10586 = cljs.core._nth.call(null,inst_10578,inst_10580);
var inst_10587 = cljs.core.nth.call(null,inst_10586,(0),null);
var inst_10588 = cljs.core.nth.call(null,inst_10586,(1),null);
var state_10696__$1 = (function (){var statearr_10768 = state_10696;
(statearr_10768[(26)] = inst_10587);

return statearr_10768;
})();
if(cljs.core.truth_(inst_10588)){
var statearr_10769_10832 = state_10696__$1;
(statearr_10769_10832[(1)] = (13));

} else {
var statearr_10770_10833 = state_10696__$1;
(statearr_10770_10833[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (18))){
var inst_10621 = (state_10696[(2)]);
var state_10696__$1 = state_10696;
var statearr_10771_10834 = state_10696__$1;
(statearr_10771_10834[(2)] = inst_10621);

(statearr_10771_10834[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (42))){
var state_10696__$1 = state_10696;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_10696__$1,(45),dchan);
} else {
if((state_val_10697 === (37))){
var inst_10655 = (state_10696[(25)]);
var inst_10664 = (state_10696[(23)]);
var inst_10568 = (state_10696[(10)]);
var inst_10664__$1 = cljs.core.first.call(null,inst_10655);
var inst_10665 = cljs.core.async.put_BANG_.call(null,inst_10664__$1,inst_10568,done);
var state_10696__$1 = (function (){var statearr_10772 = state_10696;
(statearr_10772[(23)] = inst_10664__$1);

return statearr_10772;
})();
if(cljs.core.truth_(inst_10665)){
var statearr_10773_10835 = state_10696__$1;
(statearr_10773_10835[(1)] = (39));

} else {
var statearr_10774_10836 = state_10696__$1;
(statearr_10774_10836[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_10697 === (8))){
var inst_10579 = (state_10696[(13)]);
var inst_10580 = (state_10696[(14)]);
var inst_10582 = (inst_10580 < inst_10579);
var inst_10583 = inst_10582;
var state_10696__$1 = state_10696;
if(cljs.core.truth_(inst_10583)){
var statearr_10775_10837 = state_10696__$1;
(statearr_10775_10837[(1)] = (10));

} else {
var statearr_10776_10838 = state_10696__$1;
(statearr_10776_10838[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___10784,cs,m,dchan,dctr,done))
;
return ((function (switch__6866__auto__,c__6931__auto___10784,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__6867__auto__ = null;
var cljs$core$async$mult_$_state_machine__6867__auto____0 = (function (){
var statearr_10780 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_10780[(0)] = cljs$core$async$mult_$_state_machine__6867__auto__);

(statearr_10780[(1)] = (1));

return statearr_10780;
});
var cljs$core$async$mult_$_state_machine__6867__auto____1 = (function (state_10696){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_10696);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e10781){if((e10781 instanceof Object)){
var ex__6870__auto__ = e10781;
var statearr_10782_10839 = state_10696;
(statearr_10782_10839[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_10696);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e10781;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__10840 = state_10696;
state_10696 = G__10840;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__6867__auto__ = function(state_10696){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__6867__auto____1.call(this,state_10696);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__6867__auto____0;
cljs$core$async$mult_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__6867__auto____1;
return cljs$core$async$mult_$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___10784,cs,m,dchan,dctr,done))
})();
var state__6933__auto__ = (function (){var statearr_10783 = f__6932__auto__.call(null);
(statearr_10783[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___10784);

return statearr_10783;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___10784,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 * By default the channel will be closed when the source closes,
 * but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(){
var args10841 = [];
var len__5587__auto___10844 = arguments.length;
var i__5588__auto___10845 = (0);
while(true){
if((i__5588__auto___10845 < len__5587__auto___10844)){
args10841.push((arguments[i__5588__auto___10845]));

var G__10846 = (i__5588__auto___10845 + (1));
i__5588__auto___10845 = G__10846;
continue;
} else {
}
break;
}

var G__10843 = args10841.length;
switch (G__10843) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args10841.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;
/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

cljs.core.async.Mix = {};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,ch);
} else {
var m__5185__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,ch);
} else {
var m__5185__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m);
} else {
var m__5185__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,state_map);
} else {
var m__5185__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__5184__auto__ = (((m == null))?null:m);
var m__5185__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,m,mode);
} else {
var m__5185__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(){
var args__5594__auto__ = [];
var len__5587__auto___10860 = arguments.length;
var i__5588__auto___10861 = (0);
while(true){
if((i__5588__auto___10861 < len__5587__auto___10860)){
args__5594__auto__.push((arguments[i__5588__auto___10861]));

var G__10862 = (i__5588__auto___10861 + (1));
i__5588__auto___10861 = G__10862;
continue;
} else {
}
break;
}

var argseq__5595__auto__ = ((((3) < args__5594__auto__.length))?(new cljs.core.IndexedSeq(args__5594__auto__.slice((3)),(0))):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__5595__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__10854){
var map__10855 = p__10854;
var map__10855__$1 = ((((!((map__10855 == null)))?((((map__10855.cljs$lang$protocol_mask$partition0$ & (64))) || (map__10855.cljs$core$ISeq$))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__10855):map__10855);
var opts = map__10855__$1;
var statearr_10857_10863 = state;
(statearr_10857_10863[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4425__auto__ = cljs.core.async.do_alts.call(null,((function (map__10855,map__10855__$1,opts){
return (function (val){
var statearr_10858_10864 = state;
(statearr_10858_10864[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__10855,map__10855__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4425__auto__)){
var cb = temp__4425__auto__;
var statearr_10859_10865 = state;
(statearr_10859_10865[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq10850){
var G__10851 = cljs.core.first.call(null,seq10850);
var seq10850__$1 = cljs.core.next.call(null,seq10850);
var G__10852 = cljs.core.first.call(null,seq10850__$1);
var seq10850__$2 = cljs.core.next.call(null,seq10850__$1);
var G__10853 = cljs.core.first.call(null,seq10850__$2);
var seq10850__$3 = cljs.core.next.call(null,seq10850__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__10851,G__10852,G__10853,seq10850__$3);
});
/**
 * Creates and returns a mix of one or more input channels which will
 * be put on the supplied out channel. Input sources can be added to
 * the mix with 'admix', and removed with 'unmix'. A mix supports
 * soloing, muting and pausing multiple inputs atomically using
 * 'toggle', and can solo using either muting or pausing as determined
 * by 'solo-mode'.
 * 
 * Each channel can have zero or more boolean modes set via 'toggle':
 * 
 * :solo - when true, only this (ond other soloed) channel(s) will appear
 * in the mix output channel. :mute and :pause states of soloed
 * channels are ignored. If solo-mode is :mute, non-soloed
 * channels are muted, if :pause, non-soloed channels are
 * paused.
 * 
 * :mute - muted channels will have their contents consumed but not included in the mix
 * :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t11029 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11029 = (function (change,mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta11030){
this.change = change;
this.mix = mix;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta11030 = meta11030;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11029.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_11031,meta11030__$1){
var self__ = this;
var _11031__$1 = this;
return (new cljs.core.async.t11029(self__.change,self__.mix,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta11030__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_11031){
var self__ = this;
var _11031__$1 = this;
return self__.meta11030;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t11029.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$ = true;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str(cljs.core.pr_str.call(null,cljs.core.list(new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"mode","mode",-2000032078,null))))].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),cljs.core.with_meta(new cljs.core.Symbol(null,"mix","mix",2121373763,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Creates and returns a mix of one or more input channels which will\n  be put on the supplied out channel. Input sources can be added to\n  the mix with 'admix', and removed with 'unmix'. A mix supports\n  soloing, muting and pausing multiple inputs atomically using\n  'toggle', and can solo using either muting or pausing as determined\n  by 'solo-mode'.\n\n  Each channel can have zero or more boolean modes set via 'toggle':\n\n  :solo - when true, only this (ond other soloed) channel(s) will appear\n          in the mix output channel. :mute and :pause states of soloed\n          channels are ignored. If solo-mode is :mute, non-soloed\n          channels are muted, if :pause, non-soloed channels are\n          paused.\n\n  :mute - muted channels will have their contents consumed but not included in the mix\n  :pause - paused channels will not have their contents consumed (and thus also not included in the mix)\n"], null)),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta11030","meta11030",-100741064,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t11029.cljs$lang$type = true;

cljs.core.async.t11029.cljs$lang$ctorStr = "cljs.core.async/t11029";

cljs.core.async.t11029.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11029");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t11029 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t11029(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta11030){
return (new cljs.core.async.t11029(change__$1,mix__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta11030));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t11029(change,cljs$core$async$mix,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__6931__auto___11192 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_11129){
var state_val_11130 = (state_11129[(1)]);
if((state_val_11130 === (7))){
var inst_11047 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
var statearr_11131_11193 = state_11129__$1;
(statearr_11131_11193[(2)] = inst_11047);

(statearr_11131_11193[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (20))){
var inst_11059 = (state_11129[(7)]);
var state_11129__$1 = state_11129;
var statearr_11132_11194 = state_11129__$1;
(statearr_11132_11194[(2)] = inst_11059);

(statearr_11132_11194[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (27))){
var state_11129__$1 = state_11129;
var statearr_11133_11195 = state_11129__$1;
(statearr_11133_11195[(2)] = null);

(statearr_11133_11195[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (1))){
var inst_11035 = (state_11129[(8)]);
var inst_11035__$1 = calc_state.call(null);
var inst_11037 = (inst_11035__$1 == null);
var inst_11038 = cljs.core.not.call(null,inst_11037);
var state_11129__$1 = (function (){var statearr_11134 = state_11129;
(statearr_11134[(8)] = inst_11035__$1);

return statearr_11134;
})();
if(inst_11038){
var statearr_11135_11196 = state_11129__$1;
(statearr_11135_11196[(1)] = (2));

} else {
var statearr_11136_11197 = state_11129__$1;
(statearr_11136_11197[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (24))){
var inst_11103 = (state_11129[(9)]);
var inst_11082 = (state_11129[(10)]);
var inst_11089 = (state_11129[(11)]);
var inst_11103__$1 = inst_11082.call(null,inst_11089);
var state_11129__$1 = (function (){var statearr_11137 = state_11129;
(statearr_11137[(9)] = inst_11103__$1);

return statearr_11137;
})();
if(cljs.core.truth_(inst_11103__$1)){
var statearr_11138_11198 = state_11129__$1;
(statearr_11138_11198[(1)] = (29));

} else {
var statearr_11139_11199 = state_11129__$1;
(statearr_11139_11199[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (4))){
var inst_11050 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11050)){
var statearr_11140_11200 = state_11129__$1;
(statearr_11140_11200[(1)] = (8));

} else {
var statearr_11141_11201 = state_11129__$1;
(statearr_11141_11201[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (15))){
var inst_11076 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11076)){
var statearr_11142_11202 = state_11129__$1;
(statearr_11142_11202[(1)] = (19));

} else {
var statearr_11143_11203 = state_11129__$1;
(statearr_11143_11203[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (21))){
var inst_11081 = (state_11129[(12)]);
var inst_11081__$1 = (state_11129[(2)]);
var inst_11082 = cljs.core.get.call(null,inst_11081__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_11083 = cljs.core.get.call(null,inst_11081__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_11084 = cljs.core.get.call(null,inst_11081__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_11129__$1 = (function (){var statearr_11144 = state_11129;
(statearr_11144[(13)] = inst_11083);

(statearr_11144[(10)] = inst_11082);

(statearr_11144[(12)] = inst_11081__$1);

return statearr_11144;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_11129__$1,(22),inst_11084);
} else {
if((state_val_11130 === (31))){
var inst_11111 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11111)){
var statearr_11145_11204 = state_11129__$1;
(statearr_11145_11204[(1)] = (32));

} else {
var statearr_11146_11205 = state_11129__$1;
(statearr_11146_11205[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (32))){
var inst_11088 = (state_11129[(14)]);
var state_11129__$1 = state_11129;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11129__$1,(35),out,inst_11088);
} else {
if((state_val_11130 === (33))){
var inst_11081 = (state_11129[(12)]);
var inst_11059 = inst_11081;
var state_11129__$1 = (function (){var statearr_11147 = state_11129;
(statearr_11147[(7)] = inst_11059);

return statearr_11147;
})();
var statearr_11148_11206 = state_11129__$1;
(statearr_11148_11206[(2)] = null);

(statearr_11148_11206[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (13))){
var inst_11059 = (state_11129[(7)]);
var inst_11066 = inst_11059.cljs$lang$protocol_mask$partition0$;
var inst_11067 = (inst_11066 & (64));
var inst_11068 = inst_11059.cljs$core$ISeq$;
var inst_11069 = (inst_11067) || (inst_11068);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11069)){
var statearr_11149_11207 = state_11129__$1;
(statearr_11149_11207[(1)] = (16));

} else {
var statearr_11150_11208 = state_11129__$1;
(statearr_11150_11208[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (22))){
var inst_11088 = (state_11129[(14)]);
var inst_11089 = (state_11129[(11)]);
var inst_11087 = (state_11129[(2)]);
var inst_11088__$1 = cljs.core.nth.call(null,inst_11087,(0),null);
var inst_11089__$1 = cljs.core.nth.call(null,inst_11087,(1),null);
var inst_11090 = (inst_11088__$1 == null);
var inst_11091 = cljs.core._EQ_.call(null,inst_11089__$1,change);
var inst_11092 = (inst_11090) || (inst_11091);
var state_11129__$1 = (function (){var statearr_11151 = state_11129;
(statearr_11151[(14)] = inst_11088__$1);

(statearr_11151[(11)] = inst_11089__$1);

return statearr_11151;
})();
if(cljs.core.truth_(inst_11092)){
var statearr_11152_11209 = state_11129__$1;
(statearr_11152_11209[(1)] = (23));

} else {
var statearr_11153_11210 = state_11129__$1;
(statearr_11153_11210[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (36))){
var inst_11081 = (state_11129[(12)]);
var inst_11059 = inst_11081;
var state_11129__$1 = (function (){var statearr_11154 = state_11129;
(statearr_11154[(7)] = inst_11059);

return statearr_11154;
})();
var statearr_11155_11211 = state_11129__$1;
(statearr_11155_11211[(2)] = null);

(statearr_11155_11211[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (29))){
var inst_11103 = (state_11129[(9)]);
var state_11129__$1 = state_11129;
var statearr_11156_11212 = state_11129__$1;
(statearr_11156_11212[(2)] = inst_11103);

(statearr_11156_11212[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (6))){
var state_11129__$1 = state_11129;
var statearr_11157_11213 = state_11129__$1;
(statearr_11157_11213[(2)] = false);

(statearr_11157_11213[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (28))){
var inst_11099 = (state_11129[(2)]);
var inst_11100 = calc_state.call(null);
var inst_11059 = inst_11100;
var state_11129__$1 = (function (){var statearr_11158 = state_11129;
(statearr_11158[(15)] = inst_11099);

(statearr_11158[(7)] = inst_11059);

return statearr_11158;
})();
var statearr_11159_11214 = state_11129__$1;
(statearr_11159_11214[(2)] = null);

(statearr_11159_11214[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (25))){
var inst_11125 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
var statearr_11160_11215 = state_11129__$1;
(statearr_11160_11215[(2)] = inst_11125);

(statearr_11160_11215[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (34))){
var inst_11123 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
var statearr_11161_11216 = state_11129__$1;
(statearr_11161_11216[(2)] = inst_11123);

(statearr_11161_11216[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (17))){
var state_11129__$1 = state_11129;
var statearr_11162_11217 = state_11129__$1;
(statearr_11162_11217[(2)] = false);

(statearr_11162_11217[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (3))){
var state_11129__$1 = state_11129;
var statearr_11163_11218 = state_11129__$1;
(statearr_11163_11218[(2)] = false);

(statearr_11163_11218[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (12))){
var inst_11127 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11129__$1,inst_11127);
} else {
if((state_val_11130 === (2))){
var inst_11035 = (state_11129[(8)]);
var inst_11040 = inst_11035.cljs$lang$protocol_mask$partition0$;
var inst_11041 = (inst_11040 & (64));
var inst_11042 = inst_11035.cljs$core$ISeq$;
var inst_11043 = (inst_11041) || (inst_11042);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11043)){
var statearr_11164_11219 = state_11129__$1;
(statearr_11164_11219[(1)] = (5));

} else {
var statearr_11165_11220 = state_11129__$1;
(statearr_11165_11220[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (23))){
var inst_11088 = (state_11129[(14)]);
var inst_11094 = (inst_11088 == null);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11094)){
var statearr_11166_11221 = state_11129__$1;
(statearr_11166_11221[(1)] = (26));

} else {
var statearr_11167_11222 = state_11129__$1;
(statearr_11167_11222[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (35))){
var inst_11114 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
if(cljs.core.truth_(inst_11114)){
var statearr_11168_11223 = state_11129__$1;
(statearr_11168_11223[(1)] = (36));

} else {
var statearr_11169_11224 = state_11129__$1;
(statearr_11169_11224[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (19))){
var inst_11059 = (state_11129[(7)]);
var inst_11078 = cljs.core.apply.call(null,cljs.core.hash_map,inst_11059);
var state_11129__$1 = state_11129;
var statearr_11170_11225 = state_11129__$1;
(statearr_11170_11225[(2)] = inst_11078);

(statearr_11170_11225[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (11))){
var inst_11059 = (state_11129[(7)]);
var inst_11063 = (inst_11059 == null);
var inst_11064 = cljs.core.not.call(null,inst_11063);
var state_11129__$1 = state_11129;
if(inst_11064){
var statearr_11171_11226 = state_11129__$1;
(statearr_11171_11226[(1)] = (13));

} else {
var statearr_11172_11227 = state_11129__$1;
(statearr_11172_11227[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (9))){
var inst_11035 = (state_11129[(8)]);
var state_11129__$1 = state_11129;
var statearr_11173_11228 = state_11129__$1;
(statearr_11173_11228[(2)] = inst_11035);

(statearr_11173_11228[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (5))){
var state_11129__$1 = state_11129;
var statearr_11174_11229 = state_11129__$1;
(statearr_11174_11229[(2)] = true);

(statearr_11174_11229[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (14))){
var state_11129__$1 = state_11129;
var statearr_11175_11230 = state_11129__$1;
(statearr_11175_11230[(2)] = false);

(statearr_11175_11230[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (26))){
var inst_11089 = (state_11129[(11)]);
var inst_11096 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_11089);
var state_11129__$1 = state_11129;
var statearr_11176_11231 = state_11129__$1;
(statearr_11176_11231[(2)] = inst_11096);

(statearr_11176_11231[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (16))){
var state_11129__$1 = state_11129;
var statearr_11177_11232 = state_11129__$1;
(statearr_11177_11232[(2)] = true);

(statearr_11177_11232[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (38))){
var inst_11119 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
var statearr_11178_11233 = state_11129__$1;
(statearr_11178_11233[(2)] = inst_11119);

(statearr_11178_11233[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (30))){
var inst_11083 = (state_11129[(13)]);
var inst_11082 = (state_11129[(10)]);
var inst_11089 = (state_11129[(11)]);
var inst_11106 = cljs.core.empty_QMARK_.call(null,inst_11082);
var inst_11107 = inst_11083.call(null,inst_11089);
var inst_11108 = cljs.core.not.call(null,inst_11107);
var inst_11109 = (inst_11106) && (inst_11108);
var state_11129__$1 = state_11129;
var statearr_11179_11234 = state_11129__$1;
(statearr_11179_11234[(2)] = inst_11109);

(statearr_11179_11234[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (10))){
var inst_11035 = (state_11129[(8)]);
var inst_11055 = (state_11129[(2)]);
var inst_11056 = cljs.core.get.call(null,inst_11055,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_11057 = cljs.core.get.call(null,inst_11055,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_11058 = cljs.core.get.call(null,inst_11055,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_11059 = inst_11035;
var state_11129__$1 = (function (){var statearr_11180 = state_11129;
(statearr_11180[(16)] = inst_11057);

(statearr_11180[(17)] = inst_11058);

(statearr_11180[(18)] = inst_11056);

(statearr_11180[(7)] = inst_11059);

return statearr_11180;
})();
var statearr_11181_11235 = state_11129__$1;
(statearr_11181_11235[(2)] = null);

(statearr_11181_11235[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (18))){
var inst_11073 = (state_11129[(2)]);
var state_11129__$1 = state_11129;
var statearr_11182_11236 = state_11129__$1;
(statearr_11182_11236[(2)] = inst_11073);

(statearr_11182_11236[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (37))){
var state_11129__$1 = state_11129;
var statearr_11183_11237 = state_11129__$1;
(statearr_11183_11237[(2)] = null);

(statearr_11183_11237[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11130 === (8))){
var inst_11035 = (state_11129[(8)]);
var inst_11052 = cljs.core.apply.call(null,cljs.core.hash_map,inst_11035);
var state_11129__$1 = state_11129;
var statearr_11184_11238 = state_11129__$1;
(statearr_11184_11238[(2)] = inst_11052);

(statearr_11184_11238[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__6866__auto__,c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__6867__auto__ = null;
var cljs$core$async$mix_$_state_machine__6867__auto____0 = (function (){
var statearr_11188 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11188[(0)] = cljs$core$async$mix_$_state_machine__6867__auto__);

(statearr_11188[(1)] = (1));

return statearr_11188;
});
var cljs$core$async$mix_$_state_machine__6867__auto____1 = (function (state_11129){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11129);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11189){if((e11189 instanceof Object)){
var ex__6870__auto__ = e11189;
var statearr_11190_11239 = state_11129;
(statearr_11190_11239[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11129);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11189;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11240 = state_11129;
state_11129 = G__11240;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__6867__auto__ = function(state_11129){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__6867__auto____1.call(this,state_11129);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__6867__auto____0;
cljs$core$async$mix_$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__6867__auto____1;
return cljs$core$async$mix_$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__6933__auto__ = (function (){var statearr_11191 = f__6932__auto__.call(null);
(statearr_11191[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11192);

return statearr_11191;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11192,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 * state map is a map of channels -> channel-state-map. A
 * channel-state-map is a map of attrs -> boolean, where attr is one or
 * more of :mute, :pause or :solo. Any states supplied are merged with
 * the current state.
 * 
 * Note that channels can be added to a mix via toggle, which can be
 * used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

cljs.core.async.Pub = {};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__5184__auto__ = (((p == null))?null:p);
var m__5185__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__5185__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__5184__auto__ = (((p == null))?null:p);
var m__5185__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,p,v,ch);
} else {
var m__5185__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(){
var args11243 = [];
var len__5587__auto___11246 = arguments.length;
var i__5588__auto___11247 = (0);
while(true){
if((i__5588__auto___11247 < len__5587__auto___11246)){
args11243.push((arguments[i__5588__auto___11247]));

var G__11248 = (i__5588__auto___11247 + (1));
i__5588__auto___11247 = G__11248;
continue;
} else {
}
break;
}

var G__11245 = args11243.length;
switch (G__11245) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11243.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__5184__auto__ = (((p == null))?null:p);
var m__5185__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,p);
} else {
var m__5185__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__5184__auto__ = (((p == null))?null:p);
var m__5185__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__5184__auto__)]);
if(!((m__5185__auto__ == null))){
return m__5185__auto__.call(null,p,v);
} else {
var m__5185__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__5185__auto____$1 == null))){
return m__5185__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;

/**
 * Creates and returns a pub(lication) of the supplied channel,
 * partitioned into topics by the topic-fn. topic-fn will be applied to
 * each value on the channel and the result will determine the 'topic'
 * on which that value will be put. Channels can be subscribed to
 * receive copies of topics using 'sub', and unsubscribed using
 * 'unsub'. Each topic will be handled by an internal mult on a
 * dedicated channel. By default these internal channels are
 * unbuffered, but a buf-fn can be supplied which, given a topic,
 * creates a buffer with desired properties.
 * 
 * Each item is distributed to all subs in parallel and synchronously,
 * i.e. each sub must accept before the next item is distributed. Use
 * buffering/windowing to prevent slow subs from holding up the pub.
 * 
 * Items received when there are no matching subs get dropped.
 * 
 * Note that if buf-fns are used then each topic is handled
 * asynchronously, i.e. if a channel is subscribed to more than one
 * topic it should not expect them to be interleaved identically with
 * the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(){
var args11251 = [];
var len__5587__auto___11376 = arguments.length;
var i__5588__auto___11377 = (0);
while(true){
if((i__5588__auto___11377 < len__5587__auto___11376)){
args11251.push((arguments[i__5588__auto___11377]));

var G__11378 = (i__5588__auto___11377 + (1));
i__5588__auto___11377 = G__11378;
continue;
} else {
}
break;
}

var G__11253 = args11251.length;
switch (G__11253) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11251.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__4548__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__4548__auto__)){
return or__4548__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__4548__auto__,mults){
return (function (p1__11250_SHARP_){
if(cljs.core.truth_(p1__11250_SHARP_.call(null,topic))){
return p1__11250_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__11250_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__4548__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t11254 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11254 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta11255){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta11255 = meta11255;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11254.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_11256,meta11255__$1){
var self__ = this;
var _11256__$1 = this;
return (new cljs.core.async.t11254(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta11255__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_11256){
var self__ = this;
var _11256__$1 = this;
return self__.meta11255;
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$async$Mux$ = true;

cljs.core.async.t11254.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$async$Pub$ = true;

cljs.core.async.t11254.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4425__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4425__auto__)){
var m = temp__4425__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t11254.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t11254.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta11255","meta11255",-111844645,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t11254.cljs$lang$type = true;

cljs.core.async.t11254.cljs$lang$ctorStr = "cljs.core.async/t11254";

cljs.core.async.t11254.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11254");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t11254 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t11254(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta11255){
return (new cljs.core.async.t11254(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta11255));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t11254(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__6931__auto___11380 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11380,mults,ensure_mult,p){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11380,mults,ensure_mult,p){
return (function (state_11328){
var state_val_11329 = (state_11328[(1)]);
if((state_val_11329 === (7))){
var inst_11324 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11330_11381 = state_11328__$1;
(statearr_11330_11381[(2)] = inst_11324);

(statearr_11330_11381[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (20))){
var state_11328__$1 = state_11328;
var statearr_11331_11382 = state_11328__$1;
(statearr_11331_11382[(2)] = null);

(statearr_11331_11382[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (1))){
var state_11328__$1 = state_11328;
var statearr_11332_11383 = state_11328__$1;
(statearr_11332_11383[(2)] = null);

(statearr_11332_11383[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (24))){
var inst_11307 = (state_11328[(7)]);
var inst_11316 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_11307);
var state_11328__$1 = state_11328;
var statearr_11333_11384 = state_11328__$1;
(statearr_11333_11384[(2)] = inst_11316);

(statearr_11333_11384[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (4))){
var inst_11259 = (state_11328[(8)]);
var inst_11259__$1 = (state_11328[(2)]);
var inst_11260 = (inst_11259__$1 == null);
var state_11328__$1 = (function (){var statearr_11334 = state_11328;
(statearr_11334[(8)] = inst_11259__$1);

return statearr_11334;
})();
if(cljs.core.truth_(inst_11260)){
var statearr_11335_11385 = state_11328__$1;
(statearr_11335_11385[(1)] = (5));

} else {
var statearr_11336_11386 = state_11328__$1;
(statearr_11336_11386[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (15))){
var inst_11301 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11337_11387 = state_11328__$1;
(statearr_11337_11387[(2)] = inst_11301);

(statearr_11337_11387[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (21))){
var inst_11321 = (state_11328[(2)]);
var state_11328__$1 = (function (){var statearr_11338 = state_11328;
(statearr_11338[(9)] = inst_11321);

return statearr_11338;
})();
var statearr_11339_11388 = state_11328__$1;
(statearr_11339_11388[(2)] = null);

(statearr_11339_11388[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (13))){
var inst_11283 = (state_11328[(10)]);
var inst_11285 = cljs.core.chunked_seq_QMARK_.call(null,inst_11283);
var state_11328__$1 = state_11328;
if(inst_11285){
var statearr_11340_11389 = state_11328__$1;
(statearr_11340_11389[(1)] = (16));

} else {
var statearr_11341_11390 = state_11328__$1;
(statearr_11341_11390[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (22))){
var inst_11313 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
if(cljs.core.truth_(inst_11313)){
var statearr_11342_11391 = state_11328__$1;
(statearr_11342_11391[(1)] = (23));

} else {
var statearr_11343_11392 = state_11328__$1;
(statearr_11343_11392[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (6))){
var inst_11307 = (state_11328[(7)]);
var inst_11309 = (state_11328[(11)]);
var inst_11259 = (state_11328[(8)]);
var inst_11307__$1 = topic_fn.call(null,inst_11259);
var inst_11308 = cljs.core.deref.call(null,mults);
var inst_11309__$1 = cljs.core.get.call(null,inst_11308,inst_11307__$1);
var state_11328__$1 = (function (){var statearr_11344 = state_11328;
(statearr_11344[(7)] = inst_11307__$1);

(statearr_11344[(11)] = inst_11309__$1);

return statearr_11344;
})();
if(cljs.core.truth_(inst_11309__$1)){
var statearr_11345_11393 = state_11328__$1;
(statearr_11345_11393[(1)] = (19));

} else {
var statearr_11346_11394 = state_11328__$1;
(statearr_11346_11394[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (25))){
var inst_11318 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11347_11395 = state_11328__$1;
(statearr_11347_11395[(2)] = inst_11318);

(statearr_11347_11395[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (17))){
var inst_11283 = (state_11328[(10)]);
var inst_11292 = cljs.core.first.call(null,inst_11283);
var inst_11293 = cljs.core.async.muxch_STAR_.call(null,inst_11292);
var inst_11294 = cljs.core.async.close_BANG_.call(null,inst_11293);
var inst_11295 = cljs.core.next.call(null,inst_11283);
var inst_11269 = inst_11295;
var inst_11270 = null;
var inst_11271 = (0);
var inst_11272 = (0);
var state_11328__$1 = (function (){var statearr_11348 = state_11328;
(statearr_11348[(12)] = inst_11269);

(statearr_11348[(13)] = inst_11270);

(statearr_11348[(14)] = inst_11271);

(statearr_11348[(15)] = inst_11294);

(statearr_11348[(16)] = inst_11272);

return statearr_11348;
})();
var statearr_11349_11396 = state_11328__$1;
(statearr_11349_11396[(2)] = null);

(statearr_11349_11396[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (3))){
var inst_11326 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11328__$1,inst_11326);
} else {
if((state_val_11329 === (12))){
var inst_11303 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11350_11397 = state_11328__$1;
(statearr_11350_11397[(2)] = inst_11303);

(statearr_11350_11397[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (2))){
var state_11328__$1 = state_11328;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11328__$1,(4),ch);
} else {
if((state_val_11329 === (23))){
var state_11328__$1 = state_11328;
var statearr_11351_11398 = state_11328__$1;
(statearr_11351_11398[(2)] = null);

(statearr_11351_11398[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (19))){
var inst_11309 = (state_11328[(11)]);
var inst_11259 = (state_11328[(8)]);
var inst_11311 = cljs.core.async.muxch_STAR_.call(null,inst_11309);
var state_11328__$1 = state_11328;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11328__$1,(22),inst_11311,inst_11259);
} else {
if((state_val_11329 === (11))){
var inst_11269 = (state_11328[(12)]);
var inst_11283 = (state_11328[(10)]);
var inst_11283__$1 = cljs.core.seq.call(null,inst_11269);
var state_11328__$1 = (function (){var statearr_11352 = state_11328;
(statearr_11352[(10)] = inst_11283__$1);

return statearr_11352;
})();
if(inst_11283__$1){
var statearr_11353_11399 = state_11328__$1;
(statearr_11353_11399[(1)] = (13));

} else {
var statearr_11354_11400 = state_11328__$1;
(statearr_11354_11400[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (9))){
var inst_11305 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11355_11401 = state_11328__$1;
(statearr_11355_11401[(2)] = inst_11305);

(statearr_11355_11401[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (5))){
var inst_11266 = cljs.core.deref.call(null,mults);
var inst_11267 = cljs.core.vals.call(null,inst_11266);
var inst_11268 = cljs.core.seq.call(null,inst_11267);
var inst_11269 = inst_11268;
var inst_11270 = null;
var inst_11271 = (0);
var inst_11272 = (0);
var state_11328__$1 = (function (){var statearr_11356 = state_11328;
(statearr_11356[(12)] = inst_11269);

(statearr_11356[(13)] = inst_11270);

(statearr_11356[(14)] = inst_11271);

(statearr_11356[(16)] = inst_11272);

return statearr_11356;
})();
var statearr_11357_11402 = state_11328__$1;
(statearr_11357_11402[(2)] = null);

(statearr_11357_11402[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (14))){
var state_11328__$1 = state_11328;
var statearr_11361_11403 = state_11328__$1;
(statearr_11361_11403[(2)] = null);

(statearr_11361_11403[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (16))){
var inst_11283 = (state_11328[(10)]);
var inst_11287 = cljs.core.chunk_first.call(null,inst_11283);
var inst_11288 = cljs.core.chunk_rest.call(null,inst_11283);
var inst_11289 = cljs.core.count.call(null,inst_11287);
var inst_11269 = inst_11288;
var inst_11270 = inst_11287;
var inst_11271 = inst_11289;
var inst_11272 = (0);
var state_11328__$1 = (function (){var statearr_11362 = state_11328;
(statearr_11362[(12)] = inst_11269);

(statearr_11362[(13)] = inst_11270);

(statearr_11362[(14)] = inst_11271);

(statearr_11362[(16)] = inst_11272);

return statearr_11362;
})();
var statearr_11363_11404 = state_11328__$1;
(statearr_11363_11404[(2)] = null);

(statearr_11363_11404[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (10))){
var inst_11269 = (state_11328[(12)]);
var inst_11270 = (state_11328[(13)]);
var inst_11271 = (state_11328[(14)]);
var inst_11272 = (state_11328[(16)]);
var inst_11277 = cljs.core._nth.call(null,inst_11270,inst_11272);
var inst_11278 = cljs.core.async.muxch_STAR_.call(null,inst_11277);
var inst_11279 = cljs.core.async.close_BANG_.call(null,inst_11278);
var inst_11280 = (inst_11272 + (1));
var tmp11358 = inst_11269;
var tmp11359 = inst_11270;
var tmp11360 = inst_11271;
var inst_11269__$1 = tmp11358;
var inst_11270__$1 = tmp11359;
var inst_11271__$1 = tmp11360;
var inst_11272__$1 = inst_11280;
var state_11328__$1 = (function (){var statearr_11364 = state_11328;
(statearr_11364[(12)] = inst_11269__$1);

(statearr_11364[(13)] = inst_11270__$1);

(statearr_11364[(14)] = inst_11271__$1);

(statearr_11364[(17)] = inst_11279);

(statearr_11364[(16)] = inst_11272__$1);

return statearr_11364;
})();
var statearr_11365_11405 = state_11328__$1;
(statearr_11365_11405[(2)] = null);

(statearr_11365_11405[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (18))){
var inst_11298 = (state_11328[(2)]);
var state_11328__$1 = state_11328;
var statearr_11366_11406 = state_11328__$1;
(statearr_11366_11406[(2)] = inst_11298);

(statearr_11366_11406[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11329 === (8))){
var inst_11271 = (state_11328[(14)]);
var inst_11272 = (state_11328[(16)]);
var inst_11274 = (inst_11272 < inst_11271);
var inst_11275 = inst_11274;
var state_11328__$1 = state_11328;
if(cljs.core.truth_(inst_11275)){
var statearr_11367_11407 = state_11328__$1;
(statearr_11367_11407[(1)] = (10));

} else {
var statearr_11368_11408 = state_11328__$1;
(statearr_11368_11408[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11380,mults,ensure_mult,p))
;
return ((function (switch__6866__auto__,c__6931__auto___11380,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_11372 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11372[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_11372[(1)] = (1));

return statearr_11372;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_11328){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11328);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11373){if((e11373 instanceof Object)){
var ex__6870__auto__ = e11373;
var statearr_11374_11409 = state_11328;
(statearr_11374_11409[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11328);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11373;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11410 = state_11328;
state_11328 = G__11410;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_11328){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_11328);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11380,mults,ensure_mult,p))
})();
var state__6933__auto__ = (function (){var statearr_11375 = f__6932__auto__.call(null);
(statearr_11375[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11380);

return statearr_11375;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11380,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;
/**
 * Subscribes a channel to a topic of a pub.
 * 
 * By default the channel will be closed when the source closes,
 * but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(){
var args11411 = [];
var len__5587__auto___11414 = arguments.length;
var i__5588__auto___11415 = (0);
while(true){
if((i__5588__auto___11415 < len__5587__auto___11414)){
args11411.push((arguments[i__5588__auto___11415]));

var G__11416 = (i__5588__auto___11415 + (1));
i__5588__auto___11415 = G__11416;
continue;
} else {
}
break;
}

var G__11413 = args11411.length;
switch (G__11413) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11411.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;
/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(){
var args11418 = [];
var len__5587__auto___11421 = arguments.length;
var i__5588__auto___11422 = (0);
while(true){
if((i__5588__auto___11422 < len__5587__auto___11421)){
args11418.push((arguments[i__5588__auto___11422]));

var G__11423 = (i__5588__auto___11422 + (1));
i__5588__auto___11422 = G__11423;
continue;
} else {
}
break;
}

var G__11420 = args11418.length;
switch (G__11420) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11418.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;
/**
 * Takes a function and a collection of source channels, and returns a
 * channel which contains the values produced by applying f to the set
 * of first items taken from each source channel, followed by applying
 * f to the set of second items from each channel, until any one of the
 * channels is closed, at which point the output channel will be
 * closed. The returned channel will be unbuffered by default, or a
 * buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(){
var args11425 = [];
var len__5587__auto___11496 = arguments.length;
var i__5588__auto___11497 = (0);
while(true){
if((i__5588__auto___11497 < len__5587__auto___11496)){
args11425.push((arguments[i__5588__auto___11497]));

var G__11498 = (i__5588__auto___11497 + (1));
i__5588__auto___11497 = G__11498;
continue;
} else {
}
break;
}

var G__11427 = args11425.length;
switch (G__11427) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11425.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__6931__auto___11500 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_11466){
var state_val_11467 = (state_11466[(1)]);
if((state_val_11467 === (7))){
var state_11466__$1 = state_11466;
var statearr_11468_11501 = state_11466__$1;
(statearr_11468_11501[(2)] = null);

(statearr_11468_11501[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (1))){
var state_11466__$1 = state_11466;
var statearr_11469_11502 = state_11466__$1;
(statearr_11469_11502[(2)] = null);

(statearr_11469_11502[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (4))){
var inst_11430 = (state_11466[(7)]);
var inst_11432 = (inst_11430 < cnt);
var state_11466__$1 = state_11466;
if(cljs.core.truth_(inst_11432)){
var statearr_11470_11503 = state_11466__$1;
(statearr_11470_11503[(1)] = (6));

} else {
var statearr_11471_11504 = state_11466__$1;
(statearr_11471_11504[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (15))){
var inst_11462 = (state_11466[(2)]);
var state_11466__$1 = state_11466;
var statearr_11472_11505 = state_11466__$1;
(statearr_11472_11505[(2)] = inst_11462);

(statearr_11472_11505[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (13))){
var inst_11455 = cljs.core.async.close_BANG_.call(null,out);
var state_11466__$1 = state_11466;
var statearr_11473_11506 = state_11466__$1;
(statearr_11473_11506[(2)] = inst_11455);

(statearr_11473_11506[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (6))){
var state_11466__$1 = state_11466;
var statearr_11474_11507 = state_11466__$1;
(statearr_11474_11507[(2)] = null);

(statearr_11474_11507[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (3))){
var inst_11464 = (state_11466[(2)]);
var state_11466__$1 = state_11466;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11466__$1,inst_11464);
} else {
if((state_val_11467 === (12))){
var inst_11452 = (state_11466[(8)]);
var inst_11452__$1 = (state_11466[(2)]);
var inst_11453 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_11452__$1);
var state_11466__$1 = (function (){var statearr_11475 = state_11466;
(statearr_11475[(8)] = inst_11452__$1);

return statearr_11475;
})();
if(cljs.core.truth_(inst_11453)){
var statearr_11476_11508 = state_11466__$1;
(statearr_11476_11508[(1)] = (13));

} else {
var statearr_11477_11509 = state_11466__$1;
(statearr_11477_11509[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (2))){
var inst_11429 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_11430 = (0);
var state_11466__$1 = (function (){var statearr_11478 = state_11466;
(statearr_11478[(7)] = inst_11430);

(statearr_11478[(9)] = inst_11429);

return statearr_11478;
})();
var statearr_11479_11510 = state_11466__$1;
(statearr_11479_11510[(2)] = null);

(statearr_11479_11510[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (11))){
var inst_11430 = (state_11466[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_11466,(10),Object,null,(9));
var inst_11439 = chs__$1.call(null,inst_11430);
var inst_11440 = done.call(null,inst_11430);
var inst_11441 = cljs.core.async.take_BANG_.call(null,inst_11439,inst_11440);
var state_11466__$1 = state_11466;
var statearr_11480_11511 = state_11466__$1;
(statearr_11480_11511[(2)] = inst_11441);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11466__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (9))){
var inst_11430 = (state_11466[(7)]);
var inst_11443 = (state_11466[(2)]);
var inst_11444 = (inst_11430 + (1));
var inst_11430__$1 = inst_11444;
var state_11466__$1 = (function (){var statearr_11481 = state_11466;
(statearr_11481[(10)] = inst_11443);

(statearr_11481[(7)] = inst_11430__$1);

return statearr_11481;
})();
var statearr_11482_11512 = state_11466__$1;
(statearr_11482_11512[(2)] = null);

(statearr_11482_11512[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (5))){
var inst_11450 = (state_11466[(2)]);
var state_11466__$1 = (function (){var statearr_11483 = state_11466;
(statearr_11483[(11)] = inst_11450);

return statearr_11483;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11466__$1,(12),dchan);
} else {
if((state_val_11467 === (14))){
var inst_11452 = (state_11466[(8)]);
var inst_11457 = cljs.core.apply.call(null,f,inst_11452);
var state_11466__$1 = state_11466;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11466__$1,(16),out,inst_11457);
} else {
if((state_val_11467 === (16))){
var inst_11459 = (state_11466[(2)]);
var state_11466__$1 = (function (){var statearr_11484 = state_11466;
(statearr_11484[(12)] = inst_11459);

return statearr_11484;
})();
var statearr_11485_11513 = state_11466__$1;
(statearr_11485_11513[(2)] = null);

(statearr_11485_11513[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (10))){
var inst_11434 = (state_11466[(2)]);
var inst_11435 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_11466__$1 = (function (){var statearr_11486 = state_11466;
(statearr_11486[(13)] = inst_11434);

return statearr_11486;
})();
var statearr_11487_11514 = state_11466__$1;
(statearr_11487_11514[(2)] = inst_11435);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11466__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11467 === (8))){
var inst_11448 = (state_11466[(2)]);
var state_11466__$1 = state_11466;
var statearr_11488_11515 = state_11466__$1;
(statearr_11488_11515[(2)] = inst_11448);

(statearr_11488_11515[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__6866__auto__,c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_11492 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11492[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_11492[(1)] = (1));

return statearr_11492;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_11466){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11466);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11493){if((e11493 instanceof Object)){
var ex__6870__auto__ = e11493;
var statearr_11494_11516 = state_11466;
(statearr_11494_11516[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11466);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11493;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11517 = state_11466;
state_11466 = G__11517;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_11466){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_11466);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__6933__auto__ = (function (){var statearr_11495 = f__6932__auto__.call(null);
(statearr_11495[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11500);

return statearr_11495;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11500,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;
/**
 * Takes a collection of source channels and returns a channel which
 * contains all values taken from them. The returned channel will be
 * unbuffered by default, or a buf-or-n can be supplied. The channel
 * will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(){
var args11519 = [];
var len__5587__auto___11575 = arguments.length;
var i__5588__auto___11576 = (0);
while(true){
if((i__5588__auto___11576 < len__5587__auto___11575)){
args11519.push((arguments[i__5588__auto___11576]));

var G__11577 = (i__5588__auto___11576 + (1));
i__5588__auto___11576 = G__11577;
continue;
} else {
}
break;
}

var G__11521 = args11519.length;
switch (G__11521) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11519.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___11579 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11579,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11579,out){
return (function (state_11551){
var state_val_11552 = (state_11551[(1)]);
if((state_val_11552 === (7))){
var inst_11531 = (state_11551[(7)]);
var inst_11530 = (state_11551[(8)]);
var inst_11530__$1 = (state_11551[(2)]);
var inst_11531__$1 = cljs.core.nth.call(null,inst_11530__$1,(0),null);
var inst_11532 = cljs.core.nth.call(null,inst_11530__$1,(1),null);
var inst_11533 = (inst_11531__$1 == null);
var state_11551__$1 = (function (){var statearr_11553 = state_11551;
(statearr_11553[(7)] = inst_11531__$1);

(statearr_11553[(9)] = inst_11532);

(statearr_11553[(8)] = inst_11530__$1);

return statearr_11553;
})();
if(cljs.core.truth_(inst_11533)){
var statearr_11554_11580 = state_11551__$1;
(statearr_11554_11580[(1)] = (8));

} else {
var statearr_11555_11581 = state_11551__$1;
(statearr_11555_11581[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (1))){
var inst_11522 = cljs.core.vec.call(null,chs);
var inst_11523 = inst_11522;
var state_11551__$1 = (function (){var statearr_11556 = state_11551;
(statearr_11556[(10)] = inst_11523);

return statearr_11556;
})();
var statearr_11557_11582 = state_11551__$1;
(statearr_11557_11582[(2)] = null);

(statearr_11557_11582[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (4))){
var inst_11523 = (state_11551[(10)]);
var state_11551__$1 = state_11551;
return cljs.core.async.ioc_alts_BANG_.call(null,state_11551__$1,(7),inst_11523);
} else {
if((state_val_11552 === (6))){
var inst_11547 = (state_11551[(2)]);
var state_11551__$1 = state_11551;
var statearr_11558_11583 = state_11551__$1;
(statearr_11558_11583[(2)] = inst_11547);

(statearr_11558_11583[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (3))){
var inst_11549 = (state_11551[(2)]);
var state_11551__$1 = state_11551;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11551__$1,inst_11549);
} else {
if((state_val_11552 === (2))){
var inst_11523 = (state_11551[(10)]);
var inst_11525 = cljs.core.count.call(null,inst_11523);
var inst_11526 = (inst_11525 > (0));
var state_11551__$1 = state_11551;
if(cljs.core.truth_(inst_11526)){
var statearr_11560_11584 = state_11551__$1;
(statearr_11560_11584[(1)] = (4));

} else {
var statearr_11561_11585 = state_11551__$1;
(statearr_11561_11585[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (11))){
var inst_11523 = (state_11551[(10)]);
var inst_11540 = (state_11551[(2)]);
var tmp11559 = inst_11523;
var inst_11523__$1 = tmp11559;
var state_11551__$1 = (function (){var statearr_11562 = state_11551;
(statearr_11562[(10)] = inst_11523__$1);

(statearr_11562[(11)] = inst_11540);

return statearr_11562;
})();
var statearr_11563_11586 = state_11551__$1;
(statearr_11563_11586[(2)] = null);

(statearr_11563_11586[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (9))){
var inst_11531 = (state_11551[(7)]);
var state_11551__$1 = state_11551;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11551__$1,(11),out,inst_11531);
} else {
if((state_val_11552 === (5))){
var inst_11545 = cljs.core.async.close_BANG_.call(null,out);
var state_11551__$1 = state_11551;
var statearr_11564_11587 = state_11551__$1;
(statearr_11564_11587[(2)] = inst_11545);

(statearr_11564_11587[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (10))){
var inst_11543 = (state_11551[(2)]);
var state_11551__$1 = state_11551;
var statearr_11565_11588 = state_11551__$1;
(statearr_11565_11588[(2)] = inst_11543);

(statearr_11565_11588[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11552 === (8))){
var inst_11531 = (state_11551[(7)]);
var inst_11523 = (state_11551[(10)]);
var inst_11532 = (state_11551[(9)]);
var inst_11530 = (state_11551[(8)]);
var inst_11535 = (function (){var cs = inst_11523;
var vec__11528 = inst_11530;
var v = inst_11531;
var c = inst_11532;
return ((function (cs,vec__11528,v,c,inst_11531,inst_11523,inst_11532,inst_11530,state_val_11552,c__6931__auto___11579,out){
return (function (p1__11518_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__11518_SHARP_);
});
;})(cs,vec__11528,v,c,inst_11531,inst_11523,inst_11532,inst_11530,state_val_11552,c__6931__auto___11579,out))
})();
var inst_11536 = cljs.core.filterv.call(null,inst_11535,inst_11523);
var inst_11523__$1 = inst_11536;
var state_11551__$1 = (function (){var statearr_11566 = state_11551;
(statearr_11566[(10)] = inst_11523__$1);

return statearr_11566;
})();
var statearr_11567_11589 = state_11551__$1;
(statearr_11567_11589[(2)] = null);

(statearr_11567_11589[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11579,out))
;
return ((function (switch__6866__auto__,c__6931__auto___11579,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_11571 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11571[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_11571[(1)] = (1));

return statearr_11571;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_11551){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11551);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11572){if((e11572 instanceof Object)){
var ex__6870__auto__ = e11572;
var statearr_11573_11590 = state_11551;
(statearr_11573_11590[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11551);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11572;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11591 = state_11551;
state_11551 = G__11591;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_11551){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_11551);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11579,out))
})();
var state__6933__auto__ = (function (){var statearr_11574 = f__6932__auto__.call(null);
(statearr_11574[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11579);

return statearr_11574;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11579,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;
/**
 * Returns a channel containing the single (collection) result of the
 * items taken from the channel conjoined to the supplied
 * collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 * The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(){
var args11592 = [];
var len__5587__auto___11641 = arguments.length;
var i__5588__auto___11642 = (0);
while(true){
if((i__5588__auto___11642 < len__5587__auto___11641)){
args11592.push((arguments[i__5588__auto___11642]));

var G__11643 = (i__5588__auto___11642 + (1));
i__5588__auto___11642 = G__11643;
continue;
} else {
}
break;
}

var G__11594 = args11592.length;
switch (G__11594) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11592.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___11645 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11645,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11645,out){
return (function (state_11618){
var state_val_11619 = (state_11618[(1)]);
if((state_val_11619 === (7))){
var inst_11600 = (state_11618[(7)]);
var inst_11600__$1 = (state_11618[(2)]);
var inst_11601 = (inst_11600__$1 == null);
var inst_11602 = cljs.core.not.call(null,inst_11601);
var state_11618__$1 = (function (){var statearr_11620 = state_11618;
(statearr_11620[(7)] = inst_11600__$1);

return statearr_11620;
})();
if(inst_11602){
var statearr_11621_11646 = state_11618__$1;
(statearr_11621_11646[(1)] = (8));

} else {
var statearr_11622_11647 = state_11618__$1;
(statearr_11622_11647[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (1))){
var inst_11595 = (0);
var state_11618__$1 = (function (){var statearr_11623 = state_11618;
(statearr_11623[(8)] = inst_11595);

return statearr_11623;
})();
var statearr_11624_11648 = state_11618__$1;
(statearr_11624_11648[(2)] = null);

(statearr_11624_11648[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (4))){
var state_11618__$1 = state_11618;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11618__$1,(7),ch);
} else {
if((state_val_11619 === (6))){
var inst_11613 = (state_11618[(2)]);
var state_11618__$1 = state_11618;
var statearr_11625_11649 = state_11618__$1;
(statearr_11625_11649[(2)] = inst_11613);

(statearr_11625_11649[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (3))){
var inst_11615 = (state_11618[(2)]);
var inst_11616 = cljs.core.async.close_BANG_.call(null,out);
var state_11618__$1 = (function (){var statearr_11626 = state_11618;
(statearr_11626[(9)] = inst_11615);

return statearr_11626;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11618__$1,inst_11616);
} else {
if((state_val_11619 === (2))){
var inst_11595 = (state_11618[(8)]);
var inst_11597 = (inst_11595 < n);
var state_11618__$1 = state_11618;
if(cljs.core.truth_(inst_11597)){
var statearr_11627_11650 = state_11618__$1;
(statearr_11627_11650[(1)] = (4));

} else {
var statearr_11628_11651 = state_11618__$1;
(statearr_11628_11651[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (11))){
var inst_11595 = (state_11618[(8)]);
var inst_11605 = (state_11618[(2)]);
var inst_11606 = (inst_11595 + (1));
var inst_11595__$1 = inst_11606;
var state_11618__$1 = (function (){var statearr_11629 = state_11618;
(statearr_11629[(8)] = inst_11595__$1);

(statearr_11629[(10)] = inst_11605);

return statearr_11629;
})();
var statearr_11630_11652 = state_11618__$1;
(statearr_11630_11652[(2)] = null);

(statearr_11630_11652[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (9))){
var state_11618__$1 = state_11618;
var statearr_11631_11653 = state_11618__$1;
(statearr_11631_11653[(2)] = null);

(statearr_11631_11653[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (5))){
var state_11618__$1 = state_11618;
var statearr_11632_11654 = state_11618__$1;
(statearr_11632_11654[(2)] = null);

(statearr_11632_11654[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (10))){
var inst_11610 = (state_11618[(2)]);
var state_11618__$1 = state_11618;
var statearr_11633_11655 = state_11618__$1;
(statearr_11633_11655[(2)] = inst_11610);

(statearr_11633_11655[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11619 === (8))){
var inst_11600 = (state_11618[(7)]);
var state_11618__$1 = state_11618;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11618__$1,(11),out,inst_11600);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11645,out))
;
return ((function (switch__6866__auto__,c__6931__auto___11645,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_11637 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_11637[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_11637[(1)] = (1));

return statearr_11637;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_11618){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11618);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11638){if((e11638 instanceof Object)){
var ex__6870__auto__ = e11638;
var statearr_11639_11656 = state_11618;
(statearr_11639_11656[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11618);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11638;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11657 = state_11618;
state_11618 = G__11657;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_11618){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_11618);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11645,out))
})();
var state__6933__auto__ = (function (){var statearr_11640 = f__6932__auto__.call(null);
(statearr_11640[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11645);

return statearr_11640;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11645,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t11665 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11665 = (function (map_LT_,f,ch,meta11666){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta11666 = meta11666;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11665.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_11667,meta11666__$1){
var self__ = this;
var _11667__$1 = this;
return (new cljs.core.async.t11665(self__.map_LT_,self__.f,self__.ch,meta11666__$1));
});

cljs.core.async.t11665.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_11667){
var self__ = this;
var _11667__$1 = this;
return self__.meta11666;
});

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t11668 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11668 = (function (map_LT_,f,ch,meta11666,_,fn1,meta11669){
this.map_LT_ = map_LT_;
this.f = f;
this.ch = ch;
this.meta11666 = meta11666;
this._ = _;
this.fn1 = fn1;
this.meta11669 = meta11669;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11668.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_11670,meta11669__$1){
var self__ = this;
var _11670__$1 = this;
return (new cljs.core.async.t11668(self__.map_LT_,self__.f,self__.ch,self__.meta11666,self__._,self__.fn1,meta11669__$1));
});})(___$1))
;

cljs.core.async.t11668.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_11670){
var self__ = this;
var _11670__$1 = this;
return self__.meta11669;
});})(___$1))
;

cljs.core.async.t11668.prototype.cljs$core$async$impl$protocols$Handler$ = true;

cljs.core.async.t11668.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t11668.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__11658_SHARP_){
return f1.call(null,(((p1__11658_SHARP_ == null))?null:self__.f.call(null,p1__11658_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t11668.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta11666","meta11666",201809471,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t11665","cljs.core.async/t11665",-1507696528,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta11669","meta11669",-1425906796,null)], null);
});})(___$1))
;

cljs.core.async.t11668.cljs$lang$type = true;

cljs.core.async.t11668.cljs$lang$ctorStr = "cljs.core.async/t11668";

cljs.core.async.t11668.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11668");
});})(___$1))
;

cljs.core.async.__GT_t11668 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t11668(map_LT___$1,f__$1,ch__$1,meta11666__$1,___$2,fn1__$1,meta11669){
return (new cljs.core.async.t11668(map_LT___$1,f__$1,ch__$1,meta11666__$1,___$2,fn1__$1,meta11669));
});})(___$1))
;

}

return (new cljs.core.async.t11668(self__.map_LT_,self__.f,self__.ch,self__.meta11666,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4536__auto__ = ret;
if(cljs.core.truth_(and__4536__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__4536__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t11665.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t11665.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map<","map<",-1235808357,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta11666","meta11666",201809471,null)], null);
});

cljs.core.async.t11665.cljs$lang$type = true;

cljs.core.async.t11665.cljs$lang$ctorStr = "cljs.core.async/t11665";

cljs.core.async.t11665.cljs$lang$ctorPrWriter = (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11665");
});

cljs.core.async.__GT_t11665 = (function cljs$core$async$map_LT__$___GT_t11665(map_LT___$1,f__$1,ch__$1,meta11666){
return (new cljs.core.async.t11665(map_LT___$1,f__$1,ch__$1,meta11666));
});

}

return (new cljs.core.async.t11665(cljs$core$async$map_LT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t11674 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11674 = (function (map_GT_,f,ch,meta11675){
this.map_GT_ = map_GT_;
this.f = f;
this.ch = ch;
this.meta11675 = meta11675;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11674.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_11676,meta11675__$1){
var self__ = this;
var _11676__$1 = this;
return (new cljs.core.async.t11674(self__.map_GT_,self__.f,self__.ch,meta11675__$1));
});

cljs.core.async.t11674.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_11676){
var self__ = this;
var _11676__$1 = this;
return self__.meta11675;
});

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t11674.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t11674.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"map>","map>",1676369295,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta11675","meta11675",2020435298,null)], null);
});

cljs.core.async.t11674.cljs$lang$type = true;

cljs.core.async.t11674.cljs$lang$ctorStr = "cljs.core.async/t11674";

cljs.core.async.t11674.cljs$lang$ctorPrWriter = (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11674");
});

cljs.core.async.__GT_t11674 = (function cljs$core$async$map_GT__$___GT_t11674(map_GT___$1,f__$1,ch__$1,meta11675){
return (new cljs.core.async.t11674(map_GT___$1,f__$1,ch__$1,meta11675));
});

}

return (new cljs.core.async.t11674(cljs$core$async$map_GT_,f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t11680 !== 'undefined'){
} else {

/**
* @constructor
*/
cljs.core.async.t11680 = (function (filter_GT_,p,ch,meta11681){
this.filter_GT_ = filter_GT_;
this.p = p;
this.ch = ch;
this.meta11681 = meta11681;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t11680.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_11682,meta11681__$1){
var self__ = this;
var _11682__$1 = this;
return (new cljs.core.async.t11680(self__.filter_GT_,self__.p,self__.ch,meta11681__$1));
});

cljs.core.async.t11680.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_11682){
var self__ = this;
var _11682__$1 = this;
return self__.meta11681;
});

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$Channel$ = true;

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$ReadPort$ = true;

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$WritePort$ = true;

cljs.core.async.t11680.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t11680.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"filter>","filter>",-37644455,null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"arglists","arglists",1661989754),cljs.core.list(new cljs.core.Symbol(null,"quote","quote",1377916282,null),cljs.core.list(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null)], null))),new cljs.core.Keyword(null,"doc","doc",1913296891),"Deprecated - this function will be removed. Use transducer instead"], null)),new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta11681","meta11681",45742416,null)], null);
});

cljs.core.async.t11680.cljs$lang$type = true;

cljs.core.async.t11680.cljs$lang$ctorStr = "cljs.core.async/t11680";

cljs.core.async.t11680.cljs$lang$ctorPrWriter = (function (this__5127__auto__,writer__5128__auto__,opt__5129__auto__){
return cljs.core._write.call(null,writer__5128__auto__,"cljs.core.async/t11680");
});

cljs.core.async.__GT_t11680 = (function cljs$core$async$filter_GT__$___GT_t11680(filter_GT___$1,p__$1,ch__$1,meta11681){
return (new cljs.core.async.t11680(filter_GT___$1,p__$1,ch__$1,meta11681));
});

}

return (new cljs.core.async.t11680(cljs$core$async$filter_GT_,p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(){
var args11683 = [];
var len__5587__auto___11727 = arguments.length;
var i__5588__auto___11728 = (0);
while(true){
if((i__5588__auto___11728 < len__5587__auto___11727)){
args11683.push((arguments[i__5588__auto___11728]));

var G__11729 = (i__5588__auto___11728 + (1));
i__5588__auto___11728 = G__11729;
continue;
} else {
}
break;
}

var G__11685 = args11683.length;
switch (G__11685) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11683.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___11731 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___11731,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___11731,out){
return (function (state_11706){
var state_val_11707 = (state_11706[(1)]);
if((state_val_11707 === (7))){
var inst_11702 = (state_11706[(2)]);
var state_11706__$1 = state_11706;
var statearr_11708_11732 = state_11706__$1;
(statearr_11708_11732[(2)] = inst_11702);

(statearr_11708_11732[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (1))){
var state_11706__$1 = state_11706;
var statearr_11709_11733 = state_11706__$1;
(statearr_11709_11733[(2)] = null);

(statearr_11709_11733[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (4))){
var inst_11688 = (state_11706[(7)]);
var inst_11688__$1 = (state_11706[(2)]);
var inst_11689 = (inst_11688__$1 == null);
var state_11706__$1 = (function (){var statearr_11710 = state_11706;
(statearr_11710[(7)] = inst_11688__$1);

return statearr_11710;
})();
if(cljs.core.truth_(inst_11689)){
var statearr_11711_11734 = state_11706__$1;
(statearr_11711_11734[(1)] = (5));

} else {
var statearr_11712_11735 = state_11706__$1;
(statearr_11712_11735[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (6))){
var inst_11688 = (state_11706[(7)]);
var inst_11693 = p.call(null,inst_11688);
var state_11706__$1 = state_11706;
if(cljs.core.truth_(inst_11693)){
var statearr_11713_11736 = state_11706__$1;
(statearr_11713_11736[(1)] = (8));

} else {
var statearr_11714_11737 = state_11706__$1;
(statearr_11714_11737[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (3))){
var inst_11704 = (state_11706[(2)]);
var state_11706__$1 = state_11706;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11706__$1,inst_11704);
} else {
if((state_val_11707 === (2))){
var state_11706__$1 = state_11706;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11706__$1,(4),ch);
} else {
if((state_val_11707 === (11))){
var inst_11696 = (state_11706[(2)]);
var state_11706__$1 = state_11706;
var statearr_11715_11738 = state_11706__$1;
(statearr_11715_11738[(2)] = inst_11696);

(statearr_11715_11738[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (9))){
var state_11706__$1 = state_11706;
var statearr_11716_11739 = state_11706__$1;
(statearr_11716_11739[(2)] = null);

(statearr_11716_11739[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (5))){
var inst_11691 = cljs.core.async.close_BANG_.call(null,out);
var state_11706__$1 = state_11706;
var statearr_11717_11740 = state_11706__$1;
(statearr_11717_11740[(2)] = inst_11691);

(statearr_11717_11740[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (10))){
var inst_11699 = (state_11706[(2)]);
var state_11706__$1 = (function (){var statearr_11718 = state_11706;
(statearr_11718[(8)] = inst_11699);

return statearr_11718;
})();
var statearr_11719_11741 = state_11706__$1;
(statearr_11719_11741[(2)] = null);

(statearr_11719_11741[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11707 === (8))){
var inst_11688 = (state_11706[(7)]);
var state_11706__$1 = state_11706;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11706__$1,(11),out,inst_11688);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___11731,out))
;
return ((function (switch__6866__auto__,c__6931__auto___11731,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_11723 = [null,null,null,null,null,null,null,null,null];
(statearr_11723[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_11723[(1)] = (1));

return statearr_11723;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_11706){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11706);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11724){if((e11724 instanceof Object)){
var ex__6870__auto__ = e11724;
var statearr_11725_11742 = state_11706;
(statearr_11725_11742[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11706);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11724;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11743 = state_11706;
state_11706 = G__11743;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_11706){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_11706);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___11731,out))
})();
var state__6933__auto__ = (function (){var statearr_11726 = f__6932__auto__.call(null);
(statearr_11726[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___11731);

return statearr_11726;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___11731,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(){
var args11744 = [];
var len__5587__auto___11747 = arguments.length;
var i__5588__auto___11748 = (0);
while(true){
if((i__5588__auto___11748 < len__5587__auto___11747)){
args11744.push((arguments[i__5588__auto___11748]));

var G__11749 = (i__5588__auto___11748 + (1));
i__5588__auto___11748 = G__11749;
continue;
} else {
}
break;
}

var G__11746 = args11744.length;
switch (G__11746) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11744.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;
cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__6931__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto__){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto__){
return (function (state_11916){
var state_val_11917 = (state_11916[(1)]);
if((state_val_11917 === (7))){
var inst_11912 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
var statearr_11918_11959 = state_11916__$1;
(statearr_11918_11959[(2)] = inst_11912);

(statearr_11918_11959[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (20))){
var inst_11882 = (state_11916[(7)]);
var inst_11893 = (state_11916[(2)]);
var inst_11894 = cljs.core.next.call(null,inst_11882);
var inst_11868 = inst_11894;
var inst_11869 = null;
var inst_11870 = (0);
var inst_11871 = (0);
var state_11916__$1 = (function (){var statearr_11919 = state_11916;
(statearr_11919[(8)] = inst_11870);

(statearr_11919[(9)] = inst_11868);

(statearr_11919[(10)] = inst_11869);

(statearr_11919[(11)] = inst_11893);

(statearr_11919[(12)] = inst_11871);

return statearr_11919;
})();
var statearr_11920_11960 = state_11916__$1;
(statearr_11920_11960[(2)] = null);

(statearr_11920_11960[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (1))){
var state_11916__$1 = state_11916;
var statearr_11921_11961 = state_11916__$1;
(statearr_11921_11961[(2)] = null);

(statearr_11921_11961[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (4))){
var inst_11857 = (state_11916[(13)]);
var inst_11857__$1 = (state_11916[(2)]);
var inst_11858 = (inst_11857__$1 == null);
var state_11916__$1 = (function (){var statearr_11922 = state_11916;
(statearr_11922[(13)] = inst_11857__$1);

return statearr_11922;
})();
if(cljs.core.truth_(inst_11858)){
var statearr_11923_11962 = state_11916__$1;
(statearr_11923_11962[(1)] = (5));

} else {
var statearr_11924_11963 = state_11916__$1;
(statearr_11924_11963[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (15))){
var state_11916__$1 = state_11916;
var statearr_11928_11964 = state_11916__$1;
(statearr_11928_11964[(2)] = null);

(statearr_11928_11964[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (21))){
var state_11916__$1 = state_11916;
var statearr_11929_11965 = state_11916__$1;
(statearr_11929_11965[(2)] = null);

(statearr_11929_11965[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (13))){
var inst_11870 = (state_11916[(8)]);
var inst_11868 = (state_11916[(9)]);
var inst_11869 = (state_11916[(10)]);
var inst_11871 = (state_11916[(12)]);
var inst_11878 = (state_11916[(2)]);
var inst_11879 = (inst_11871 + (1));
var tmp11925 = inst_11870;
var tmp11926 = inst_11868;
var tmp11927 = inst_11869;
var inst_11868__$1 = tmp11926;
var inst_11869__$1 = tmp11927;
var inst_11870__$1 = tmp11925;
var inst_11871__$1 = inst_11879;
var state_11916__$1 = (function (){var statearr_11930 = state_11916;
(statearr_11930[(8)] = inst_11870__$1);

(statearr_11930[(9)] = inst_11868__$1);

(statearr_11930[(10)] = inst_11869__$1);

(statearr_11930[(12)] = inst_11871__$1);

(statearr_11930[(14)] = inst_11878);

return statearr_11930;
})();
var statearr_11931_11966 = state_11916__$1;
(statearr_11931_11966[(2)] = null);

(statearr_11931_11966[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (22))){
var state_11916__$1 = state_11916;
var statearr_11932_11967 = state_11916__$1;
(statearr_11932_11967[(2)] = null);

(statearr_11932_11967[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (6))){
var inst_11857 = (state_11916[(13)]);
var inst_11866 = f.call(null,inst_11857);
var inst_11867 = cljs.core.seq.call(null,inst_11866);
var inst_11868 = inst_11867;
var inst_11869 = null;
var inst_11870 = (0);
var inst_11871 = (0);
var state_11916__$1 = (function (){var statearr_11933 = state_11916;
(statearr_11933[(8)] = inst_11870);

(statearr_11933[(9)] = inst_11868);

(statearr_11933[(10)] = inst_11869);

(statearr_11933[(12)] = inst_11871);

return statearr_11933;
})();
var statearr_11934_11968 = state_11916__$1;
(statearr_11934_11968[(2)] = null);

(statearr_11934_11968[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (17))){
var inst_11882 = (state_11916[(7)]);
var inst_11886 = cljs.core.chunk_first.call(null,inst_11882);
var inst_11887 = cljs.core.chunk_rest.call(null,inst_11882);
var inst_11888 = cljs.core.count.call(null,inst_11886);
var inst_11868 = inst_11887;
var inst_11869 = inst_11886;
var inst_11870 = inst_11888;
var inst_11871 = (0);
var state_11916__$1 = (function (){var statearr_11935 = state_11916;
(statearr_11935[(8)] = inst_11870);

(statearr_11935[(9)] = inst_11868);

(statearr_11935[(10)] = inst_11869);

(statearr_11935[(12)] = inst_11871);

return statearr_11935;
})();
var statearr_11936_11969 = state_11916__$1;
(statearr_11936_11969[(2)] = null);

(statearr_11936_11969[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (3))){
var inst_11914 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_11916__$1,inst_11914);
} else {
if((state_val_11917 === (12))){
var inst_11902 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
var statearr_11937_11970 = state_11916__$1;
(statearr_11937_11970[(2)] = inst_11902);

(statearr_11937_11970[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (2))){
var state_11916__$1 = state_11916;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_11916__$1,(4),in$);
} else {
if((state_val_11917 === (23))){
var inst_11910 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
var statearr_11938_11971 = state_11916__$1;
(statearr_11938_11971[(2)] = inst_11910);

(statearr_11938_11971[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (19))){
var inst_11897 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
var statearr_11939_11972 = state_11916__$1;
(statearr_11939_11972[(2)] = inst_11897);

(statearr_11939_11972[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (11))){
var inst_11882 = (state_11916[(7)]);
var inst_11868 = (state_11916[(9)]);
var inst_11882__$1 = cljs.core.seq.call(null,inst_11868);
var state_11916__$1 = (function (){var statearr_11940 = state_11916;
(statearr_11940[(7)] = inst_11882__$1);

return statearr_11940;
})();
if(inst_11882__$1){
var statearr_11941_11973 = state_11916__$1;
(statearr_11941_11973[(1)] = (14));

} else {
var statearr_11942_11974 = state_11916__$1;
(statearr_11942_11974[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (9))){
var inst_11904 = (state_11916[(2)]);
var inst_11905 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_11916__$1 = (function (){var statearr_11943 = state_11916;
(statearr_11943[(15)] = inst_11904);

return statearr_11943;
})();
if(cljs.core.truth_(inst_11905)){
var statearr_11944_11975 = state_11916__$1;
(statearr_11944_11975[(1)] = (21));

} else {
var statearr_11945_11976 = state_11916__$1;
(statearr_11945_11976[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (5))){
var inst_11860 = cljs.core.async.close_BANG_.call(null,out);
var state_11916__$1 = state_11916;
var statearr_11946_11977 = state_11916__$1;
(statearr_11946_11977[(2)] = inst_11860);

(statearr_11946_11977[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (14))){
var inst_11882 = (state_11916[(7)]);
var inst_11884 = cljs.core.chunked_seq_QMARK_.call(null,inst_11882);
var state_11916__$1 = state_11916;
if(inst_11884){
var statearr_11947_11978 = state_11916__$1;
(statearr_11947_11978[(1)] = (17));

} else {
var statearr_11948_11979 = state_11916__$1;
(statearr_11948_11979[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (16))){
var inst_11900 = (state_11916[(2)]);
var state_11916__$1 = state_11916;
var statearr_11949_11980 = state_11916__$1;
(statearr_11949_11980[(2)] = inst_11900);

(statearr_11949_11980[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_11917 === (10))){
var inst_11869 = (state_11916[(10)]);
var inst_11871 = (state_11916[(12)]);
var inst_11876 = cljs.core._nth.call(null,inst_11869,inst_11871);
var state_11916__$1 = state_11916;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11916__$1,(13),out,inst_11876);
} else {
if((state_val_11917 === (18))){
var inst_11882 = (state_11916[(7)]);
var inst_11891 = cljs.core.first.call(null,inst_11882);
var state_11916__$1 = state_11916;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_11916__$1,(20),out,inst_11891);
} else {
if((state_val_11917 === (8))){
var inst_11870 = (state_11916[(8)]);
var inst_11871 = (state_11916[(12)]);
var inst_11873 = (inst_11871 < inst_11870);
var inst_11874 = inst_11873;
var state_11916__$1 = state_11916;
if(cljs.core.truth_(inst_11874)){
var statearr_11950_11981 = state_11916__$1;
(statearr_11950_11981[(1)] = (10));

} else {
var statearr_11951_11982 = state_11916__$1;
(statearr_11951_11982[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto__))
;
return ((function (switch__6866__auto__,c__6931__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____0 = (function (){
var statearr_11955 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_11955[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__);

(statearr_11955[(1)] = (1));

return statearr_11955;
});
var cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____1 = (function (state_11916){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_11916);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e11956){if((e11956 instanceof Object)){
var ex__6870__auto__ = e11956;
var statearr_11957_11983 = state_11916;
(statearr_11957_11983[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_11916);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e11956;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__11984 = state_11916;
state_11916 = G__11984;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__ = function(state_11916){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____1.call(this,state_11916);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__6867__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto__))
})();
var state__6933__auto__ = (function (){var statearr_11958 = f__6932__auto__.call(null);
(statearr_11958[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto__);

return statearr_11958;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto__))
);

return c__6931__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(){
var args11985 = [];
var len__5587__auto___11988 = arguments.length;
var i__5588__auto___11989 = (0);
while(true){
if((i__5588__auto___11989 < len__5587__auto___11988)){
args11985.push((arguments[i__5588__auto___11989]));

var G__11990 = (i__5588__auto___11989 + (1));
i__5588__auto___11989 = G__11990;
continue;
} else {
}
break;
}

var G__11987 = args11985.length;
switch (G__11987) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11985.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(){
var args11992 = [];
var len__5587__auto___11995 = arguments.length;
var i__5588__auto___11996 = (0);
while(true){
if((i__5588__auto___11996 < len__5587__auto___11995)){
args11992.push((arguments[i__5588__auto___11996]));

var G__11997 = (i__5588__auto___11996 + (1));
i__5588__auto___11996 = G__11997;
continue;
} else {
}
break;
}

var G__11994 = args11992.length;
switch (G__11994) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11992.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(){
var args11999 = [];
var len__5587__auto___12050 = arguments.length;
var i__5588__auto___12051 = (0);
while(true){
if((i__5588__auto___12051 < len__5587__auto___12050)){
args11999.push((arguments[i__5588__auto___12051]));

var G__12052 = (i__5588__auto___12051 + (1));
i__5588__auto___12051 = G__12052;
continue;
} else {
}
break;
}

var G__12001 = args11999.length;
switch (G__12001) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args11999.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___12054 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___12054,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___12054,out){
return (function (state_12025){
var state_val_12026 = (state_12025[(1)]);
if((state_val_12026 === (7))){
var inst_12020 = (state_12025[(2)]);
var state_12025__$1 = state_12025;
var statearr_12027_12055 = state_12025__$1;
(statearr_12027_12055[(2)] = inst_12020);

(statearr_12027_12055[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (1))){
var inst_12002 = null;
var state_12025__$1 = (function (){var statearr_12028 = state_12025;
(statearr_12028[(7)] = inst_12002);

return statearr_12028;
})();
var statearr_12029_12056 = state_12025__$1;
(statearr_12029_12056[(2)] = null);

(statearr_12029_12056[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (4))){
var inst_12005 = (state_12025[(8)]);
var inst_12005__$1 = (state_12025[(2)]);
var inst_12006 = (inst_12005__$1 == null);
var inst_12007 = cljs.core.not.call(null,inst_12006);
var state_12025__$1 = (function (){var statearr_12030 = state_12025;
(statearr_12030[(8)] = inst_12005__$1);

return statearr_12030;
})();
if(inst_12007){
var statearr_12031_12057 = state_12025__$1;
(statearr_12031_12057[(1)] = (5));

} else {
var statearr_12032_12058 = state_12025__$1;
(statearr_12032_12058[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (6))){
var state_12025__$1 = state_12025;
var statearr_12033_12059 = state_12025__$1;
(statearr_12033_12059[(2)] = null);

(statearr_12033_12059[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (3))){
var inst_12022 = (state_12025[(2)]);
var inst_12023 = cljs.core.async.close_BANG_.call(null,out);
var state_12025__$1 = (function (){var statearr_12034 = state_12025;
(statearr_12034[(9)] = inst_12022);

return statearr_12034;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12025__$1,inst_12023);
} else {
if((state_val_12026 === (2))){
var state_12025__$1 = state_12025;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12025__$1,(4),ch);
} else {
if((state_val_12026 === (11))){
var inst_12005 = (state_12025[(8)]);
var inst_12014 = (state_12025[(2)]);
var inst_12002 = inst_12005;
var state_12025__$1 = (function (){var statearr_12035 = state_12025;
(statearr_12035[(10)] = inst_12014);

(statearr_12035[(7)] = inst_12002);

return statearr_12035;
})();
var statearr_12036_12060 = state_12025__$1;
(statearr_12036_12060[(2)] = null);

(statearr_12036_12060[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (9))){
var inst_12005 = (state_12025[(8)]);
var state_12025__$1 = state_12025;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12025__$1,(11),out,inst_12005);
} else {
if((state_val_12026 === (5))){
var inst_12002 = (state_12025[(7)]);
var inst_12005 = (state_12025[(8)]);
var inst_12009 = cljs.core._EQ_.call(null,inst_12005,inst_12002);
var state_12025__$1 = state_12025;
if(inst_12009){
var statearr_12038_12061 = state_12025__$1;
(statearr_12038_12061[(1)] = (8));

} else {
var statearr_12039_12062 = state_12025__$1;
(statearr_12039_12062[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (10))){
var inst_12017 = (state_12025[(2)]);
var state_12025__$1 = state_12025;
var statearr_12040_12063 = state_12025__$1;
(statearr_12040_12063[(2)] = inst_12017);

(statearr_12040_12063[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12026 === (8))){
var inst_12002 = (state_12025[(7)]);
var tmp12037 = inst_12002;
var inst_12002__$1 = tmp12037;
var state_12025__$1 = (function (){var statearr_12041 = state_12025;
(statearr_12041[(7)] = inst_12002__$1);

return statearr_12041;
})();
var statearr_12042_12064 = state_12025__$1;
(statearr_12042_12064[(2)] = null);

(statearr_12042_12064[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___12054,out))
;
return ((function (switch__6866__auto__,c__6931__auto___12054,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_12046 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_12046[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_12046[(1)] = (1));

return statearr_12046;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_12025){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_12025);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e12047){if((e12047 instanceof Object)){
var ex__6870__auto__ = e12047;
var statearr_12048_12065 = state_12025;
(statearr_12048_12065[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12025);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12047;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12066 = state_12025;
state_12025 = G__12066;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_12025){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_12025);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___12054,out))
})();
var state__6933__auto__ = (function (){var statearr_12049 = f__6932__auto__.call(null);
(statearr_12049[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___12054);

return statearr_12049;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___12054,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(){
var args12067 = [];
var len__5587__auto___12137 = arguments.length;
var i__5588__auto___12138 = (0);
while(true){
if((i__5588__auto___12138 < len__5587__auto___12137)){
args12067.push((arguments[i__5588__auto___12138]));

var G__12139 = (i__5588__auto___12138 + (1));
i__5588__auto___12138 = G__12139;
continue;
} else {
}
break;
}

var G__12069 = args12067.length;
switch (G__12069) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12067.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___12141 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___12141,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___12141,out){
return (function (state_12107){
var state_val_12108 = (state_12107[(1)]);
if((state_val_12108 === (7))){
var inst_12103 = (state_12107[(2)]);
var state_12107__$1 = state_12107;
var statearr_12109_12142 = state_12107__$1;
(statearr_12109_12142[(2)] = inst_12103);

(statearr_12109_12142[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (1))){
var inst_12070 = (new Array(n));
var inst_12071 = inst_12070;
var inst_12072 = (0);
var state_12107__$1 = (function (){var statearr_12110 = state_12107;
(statearr_12110[(7)] = inst_12071);

(statearr_12110[(8)] = inst_12072);

return statearr_12110;
})();
var statearr_12111_12143 = state_12107__$1;
(statearr_12111_12143[(2)] = null);

(statearr_12111_12143[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (4))){
var inst_12075 = (state_12107[(9)]);
var inst_12075__$1 = (state_12107[(2)]);
var inst_12076 = (inst_12075__$1 == null);
var inst_12077 = cljs.core.not.call(null,inst_12076);
var state_12107__$1 = (function (){var statearr_12112 = state_12107;
(statearr_12112[(9)] = inst_12075__$1);

return statearr_12112;
})();
if(inst_12077){
var statearr_12113_12144 = state_12107__$1;
(statearr_12113_12144[(1)] = (5));

} else {
var statearr_12114_12145 = state_12107__$1;
(statearr_12114_12145[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (15))){
var inst_12097 = (state_12107[(2)]);
var state_12107__$1 = state_12107;
var statearr_12115_12146 = state_12107__$1;
(statearr_12115_12146[(2)] = inst_12097);

(statearr_12115_12146[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (13))){
var state_12107__$1 = state_12107;
var statearr_12116_12147 = state_12107__$1;
(statearr_12116_12147[(2)] = null);

(statearr_12116_12147[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (6))){
var inst_12072 = (state_12107[(8)]);
var inst_12093 = (inst_12072 > (0));
var state_12107__$1 = state_12107;
if(cljs.core.truth_(inst_12093)){
var statearr_12117_12148 = state_12107__$1;
(statearr_12117_12148[(1)] = (12));

} else {
var statearr_12118_12149 = state_12107__$1;
(statearr_12118_12149[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (3))){
var inst_12105 = (state_12107[(2)]);
var state_12107__$1 = state_12107;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12107__$1,inst_12105);
} else {
if((state_val_12108 === (12))){
var inst_12071 = (state_12107[(7)]);
var inst_12095 = cljs.core.vec.call(null,inst_12071);
var state_12107__$1 = state_12107;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12107__$1,(15),out,inst_12095);
} else {
if((state_val_12108 === (2))){
var state_12107__$1 = state_12107;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12107__$1,(4),ch);
} else {
if((state_val_12108 === (11))){
var inst_12087 = (state_12107[(2)]);
var inst_12088 = (new Array(n));
var inst_12071 = inst_12088;
var inst_12072 = (0);
var state_12107__$1 = (function (){var statearr_12119 = state_12107;
(statearr_12119[(10)] = inst_12087);

(statearr_12119[(7)] = inst_12071);

(statearr_12119[(8)] = inst_12072);

return statearr_12119;
})();
var statearr_12120_12150 = state_12107__$1;
(statearr_12120_12150[(2)] = null);

(statearr_12120_12150[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (9))){
var inst_12071 = (state_12107[(7)]);
var inst_12085 = cljs.core.vec.call(null,inst_12071);
var state_12107__$1 = state_12107;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12107__$1,(11),out,inst_12085);
} else {
if((state_val_12108 === (5))){
var inst_12075 = (state_12107[(9)]);
var inst_12071 = (state_12107[(7)]);
var inst_12072 = (state_12107[(8)]);
var inst_12080 = (state_12107[(11)]);
var inst_12079 = (inst_12071[inst_12072] = inst_12075);
var inst_12080__$1 = (inst_12072 + (1));
var inst_12081 = (inst_12080__$1 < n);
var state_12107__$1 = (function (){var statearr_12121 = state_12107;
(statearr_12121[(12)] = inst_12079);

(statearr_12121[(11)] = inst_12080__$1);

return statearr_12121;
})();
if(cljs.core.truth_(inst_12081)){
var statearr_12122_12151 = state_12107__$1;
(statearr_12122_12151[(1)] = (8));

} else {
var statearr_12123_12152 = state_12107__$1;
(statearr_12123_12152[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (14))){
var inst_12100 = (state_12107[(2)]);
var inst_12101 = cljs.core.async.close_BANG_.call(null,out);
var state_12107__$1 = (function (){var statearr_12125 = state_12107;
(statearr_12125[(13)] = inst_12100);

return statearr_12125;
})();
var statearr_12126_12153 = state_12107__$1;
(statearr_12126_12153[(2)] = inst_12101);

(statearr_12126_12153[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (10))){
var inst_12091 = (state_12107[(2)]);
var state_12107__$1 = state_12107;
var statearr_12127_12154 = state_12107__$1;
(statearr_12127_12154[(2)] = inst_12091);

(statearr_12127_12154[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12108 === (8))){
var inst_12071 = (state_12107[(7)]);
var inst_12080 = (state_12107[(11)]);
var tmp12124 = inst_12071;
var inst_12071__$1 = tmp12124;
var inst_12072 = inst_12080;
var state_12107__$1 = (function (){var statearr_12128 = state_12107;
(statearr_12128[(7)] = inst_12071__$1);

(statearr_12128[(8)] = inst_12072);

return statearr_12128;
})();
var statearr_12129_12155 = state_12107__$1;
(statearr_12129_12155[(2)] = null);

(statearr_12129_12155[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___12141,out))
;
return ((function (switch__6866__auto__,c__6931__auto___12141,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_12133 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12133[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_12133[(1)] = (1));

return statearr_12133;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_12107){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_12107);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e12134){if((e12134 instanceof Object)){
var ex__6870__auto__ = e12134;
var statearr_12135_12156 = state_12107;
(statearr_12135_12156[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12107);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12134;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12157 = state_12107;
state_12107 = G__12157;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_12107){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_12107);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___12141,out))
})();
var state__6933__auto__ = (function (){var statearr_12136 = f__6932__auto__.call(null);
(statearr_12136[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___12141);

return statearr_12136;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___12141,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(){
var args12158 = [];
var len__5587__auto___12232 = arguments.length;
var i__5588__auto___12233 = (0);
while(true){
if((i__5588__auto___12233 < len__5587__auto___12232)){
args12158.push((arguments[i__5588__auto___12233]));

var G__12234 = (i__5588__auto___12233 + (1));
i__5588__auto___12233 = G__12234;
continue;
} else {
}
break;
}

var G__12160 = args12158.length;
switch (G__12160) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args12158.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__6931__auto___12236 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__6931__auto___12236,out){
return (function (){
var f__6932__auto__ = (function (){var switch__6866__auto__ = ((function (c__6931__auto___12236,out){
return (function (state_12202){
var state_val_12203 = (state_12202[(1)]);
if((state_val_12203 === (7))){
var inst_12198 = (state_12202[(2)]);
var state_12202__$1 = state_12202;
var statearr_12204_12237 = state_12202__$1;
(statearr_12204_12237[(2)] = inst_12198);

(statearr_12204_12237[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (1))){
var inst_12161 = [];
var inst_12162 = inst_12161;
var inst_12163 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_12202__$1 = (function (){var statearr_12205 = state_12202;
(statearr_12205[(7)] = inst_12163);

(statearr_12205[(8)] = inst_12162);

return statearr_12205;
})();
var statearr_12206_12238 = state_12202__$1;
(statearr_12206_12238[(2)] = null);

(statearr_12206_12238[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (4))){
var inst_12166 = (state_12202[(9)]);
var inst_12166__$1 = (state_12202[(2)]);
var inst_12167 = (inst_12166__$1 == null);
var inst_12168 = cljs.core.not.call(null,inst_12167);
var state_12202__$1 = (function (){var statearr_12207 = state_12202;
(statearr_12207[(9)] = inst_12166__$1);

return statearr_12207;
})();
if(inst_12168){
var statearr_12208_12239 = state_12202__$1;
(statearr_12208_12239[(1)] = (5));

} else {
var statearr_12209_12240 = state_12202__$1;
(statearr_12209_12240[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (15))){
var inst_12192 = (state_12202[(2)]);
var state_12202__$1 = state_12202;
var statearr_12210_12241 = state_12202__$1;
(statearr_12210_12241[(2)] = inst_12192);

(statearr_12210_12241[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (13))){
var state_12202__$1 = state_12202;
var statearr_12211_12242 = state_12202__$1;
(statearr_12211_12242[(2)] = null);

(statearr_12211_12242[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (6))){
var inst_12162 = (state_12202[(8)]);
var inst_12187 = inst_12162.length;
var inst_12188 = (inst_12187 > (0));
var state_12202__$1 = state_12202;
if(cljs.core.truth_(inst_12188)){
var statearr_12212_12243 = state_12202__$1;
(statearr_12212_12243[(1)] = (12));

} else {
var statearr_12213_12244 = state_12202__$1;
(statearr_12213_12244[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (3))){
var inst_12200 = (state_12202[(2)]);
var state_12202__$1 = state_12202;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_12202__$1,inst_12200);
} else {
if((state_val_12203 === (12))){
var inst_12162 = (state_12202[(8)]);
var inst_12190 = cljs.core.vec.call(null,inst_12162);
var state_12202__$1 = state_12202;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12202__$1,(15),out,inst_12190);
} else {
if((state_val_12203 === (2))){
var state_12202__$1 = state_12202;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_12202__$1,(4),ch);
} else {
if((state_val_12203 === (11))){
var inst_12170 = (state_12202[(10)]);
var inst_12166 = (state_12202[(9)]);
var inst_12180 = (state_12202[(2)]);
var inst_12181 = [];
var inst_12182 = inst_12181.push(inst_12166);
var inst_12162 = inst_12181;
var inst_12163 = inst_12170;
var state_12202__$1 = (function (){var statearr_12214 = state_12202;
(statearr_12214[(11)] = inst_12182);

(statearr_12214[(7)] = inst_12163);

(statearr_12214[(12)] = inst_12180);

(statearr_12214[(8)] = inst_12162);

return statearr_12214;
})();
var statearr_12215_12245 = state_12202__$1;
(statearr_12215_12245[(2)] = null);

(statearr_12215_12245[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (9))){
var inst_12162 = (state_12202[(8)]);
var inst_12178 = cljs.core.vec.call(null,inst_12162);
var state_12202__$1 = state_12202;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_12202__$1,(11),out,inst_12178);
} else {
if((state_val_12203 === (5))){
var inst_12163 = (state_12202[(7)]);
var inst_12170 = (state_12202[(10)]);
var inst_12166 = (state_12202[(9)]);
var inst_12170__$1 = f.call(null,inst_12166);
var inst_12171 = cljs.core._EQ_.call(null,inst_12170__$1,inst_12163);
var inst_12172 = cljs.core.keyword_identical_QMARK_.call(null,inst_12163,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_12173 = (inst_12171) || (inst_12172);
var state_12202__$1 = (function (){var statearr_12216 = state_12202;
(statearr_12216[(10)] = inst_12170__$1);

return statearr_12216;
})();
if(cljs.core.truth_(inst_12173)){
var statearr_12217_12246 = state_12202__$1;
(statearr_12217_12246[(1)] = (8));

} else {
var statearr_12218_12247 = state_12202__$1;
(statearr_12218_12247[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (14))){
var inst_12195 = (state_12202[(2)]);
var inst_12196 = cljs.core.async.close_BANG_.call(null,out);
var state_12202__$1 = (function (){var statearr_12220 = state_12202;
(statearr_12220[(13)] = inst_12195);

return statearr_12220;
})();
var statearr_12221_12248 = state_12202__$1;
(statearr_12221_12248[(2)] = inst_12196);

(statearr_12221_12248[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (10))){
var inst_12185 = (state_12202[(2)]);
var state_12202__$1 = state_12202;
var statearr_12222_12249 = state_12202__$1;
(statearr_12222_12249[(2)] = inst_12185);

(statearr_12222_12249[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_12203 === (8))){
var inst_12170 = (state_12202[(10)]);
var inst_12166 = (state_12202[(9)]);
var inst_12162 = (state_12202[(8)]);
var inst_12175 = inst_12162.push(inst_12166);
var tmp12219 = inst_12162;
var inst_12162__$1 = tmp12219;
var inst_12163 = inst_12170;
var state_12202__$1 = (function (){var statearr_12223 = state_12202;
(statearr_12223[(14)] = inst_12175);

(statearr_12223[(7)] = inst_12163);

(statearr_12223[(8)] = inst_12162__$1);

return statearr_12223;
})();
var statearr_12224_12250 = state_12202__$1;
(statearr_12224_12250[(2)] = null);

(statearr_12224_12250[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__6931__auto___12236,out))
;
return ((function (switch__6866__auto__,c__6931__auto___12236,out){
return (function() {
var cljs$core$async$state_machine__6867__auto__ = null;
var cljs$core$async$state_machine__6867__auto____0 = (function (){
var statearr_12228 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_12228[(0)] = cljs$core$async$state_machine__6867__auto__);

(statearr_12228[(1)] = (1));

return statearr_12228;
});
var cljs$core$async$state_machine__6867__auto____1 = (function (state_12202){
while(true){
var ret_value__6868__auto__ = (function (){try{while(true){
var result__6869__auto__ = switch__6866__auto__.call(null,state_12202);
if(cljs.core.keyword_identical_QMARK_.call(null,result__6869__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__6869__auto__;
}
break;
}
}catch (e12229){if((e12229 instanceof Object)){
var ex__6870__auto__ = e12229;
var statearr_12230_12251 = state_12202;
(statearr_12230_12251[(5)] = ex__6870__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_12202);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e12229;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__6868__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__12252 = state_12202;
state_12202 = G__12252;
continue;
} else {
return ret_value__6868__auto__;
}
break;
}
});
cljs$core$async$state_machine__6867__auto__ = function(state_12202){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__6867__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__6867__auto____1.call(this,state_12202);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__6867__auto____0;
cljs$core$async$state_machine__6867__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__6867__auto____1;
return cljs$core$async$state_machine__6867__auto__;
})()
;})(switch__6866__auto__,c__6931__auto___12236,out))
})();
var state__6933__auto__ = (function (){var statearr_12231 = f__6932__auto__.call(null);
(statearr_12231[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__6931__auto___12236);

return statearr_12231;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__6933__auto__);
});})(c__6931__auto___12236,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

//# sourceMappingURL=async.js.map